#!/bin/bash

echo "Init"

fsck -a /dev/mmcblk0p3 | tail -n 1

mount -t proc proc /proc

mount -o remount,rw /

# sysfs

echo "  Sysfs"
mount -n -t sysfs -o nodev,noexec,nosuid sysfs /sys
mount -n -t debugfs -o nodev,noexec,nosuid debugfs /sys/kernel/debug
mount -n -t tmpfs -o nodev,noexec,nosuid,mode=755,size=10m cgroup_root /sys/fs/cgroup


# devfs

#echo "  Devfs"
#mount -n -t devtmpfs -o exec,nosuid,mode=0755,size=10M dev /dev

[ -c /dev/console ] || mknod -m 600 /dev/console c 5 1
[ -c /dev/tty1 ] || mknod -m 620 /dev/tty1 c 4 1
[ -c /dev/tty ] || mknod -m 666 /dev/tty c 5 0
[ -c /dev/null ] || mknod -m 666 /dev/null c 1 3
[ -c /dev/kmsg ] || mknod -m 660 /dev/kmsg c 1 11
[ -c /dev/mtd0 ] || mknod -m 660 /dev/mtd0 c 90 0
[ -b /dev/mtdblock1 ] || mknod -m 660 /dev/mtdblock1 b 31 1
[ -e /dev/fd ] || ln -snf /proc/self/fd /dev/fd
[ -e /dev/stdin ] || ln -snf /proc/self/fd/0 /dev/stdin
[ -e /dev/stdout ] || ln -snf /proc/self/fd/1 /dev/stdout
[ -e /dev/stderr ] || ln -snf /proc/self/fd/2 /dev/stderr
[ -e /proc/kcore ] && ln -snf /proc/kcore /dev/core

mkdir /dev/mqueue
mount -n -t mqueue -o noexec,nosuid,nodev mqueue /dev/mqueue
mkdir /dev/pts
mount -n -t devpts -o noexec,nosuid,gid=5,mode=0620 devpts /dev/pts
mkdir /dev/shm
mount -n -t tmpfs -o noexec,nosuid,nodev,mode=1777 shm /dev/shm


# tmpfiles.dev

#/lib/rc/sh/tmpfiles.sh --prefix=/dev --create --boot --verbose

# udev

echo "  udev"
udevadm control --reload




