#!/bin/sh
#
# Checks for certain files in archive
#
# @version 1 (19.07.2013) florian.faber@directout.eu
#            - initial version
#
# Exit values:
#    0 - type mismatch
#    1 - type matches
#   10 - file not found
#   11 - parameters
#

if [ $# -ne 2 ]
then
  echo "Usage: $0 <upgrade file> <boundary>"
  exit 11
fi

if [ ! -f $1 ]
then
  echo "File '$1' not found."
  exit 10
fi

HEADER=`/system/multipart_extract $1 file $2 | dd bs=1 count=3 status=none`

if [ "$HEADER" == "BZh" ]; then
  FILE=`/system/multipart_extract $1 file $2 | bzip2 -d | tar -t | head -n1`
else
  FILE=`/system/multipart_extract $1 file $2 | tar -t | head -n1`
fi

echo $FILE

exit 0
