#!/bin/sh
#
# Unpacks and installs a system configuration
#
# @version 1 (18.11.2011) florian.faber@directout.eu
#            - initial version
#
# Exit values:
#   0 - OK
#   1 - Empty parameter
#   2 - File not found
#

if [ $# -ne 4 ]
then
  echo "Usage: $0 <dev> <user> <upgrade file> <boundary>"
  exit 1
fi

if [ ! -f $3 ]
then
  echo "File '$3' not found."
  exit 2
fi

TMPDIR=/var/config

rm -rf $TMPDIR 2>/dev/null

mkdir $TMPDIR

HEADER=`/system/multipart_extract $3 file $4 | dd bs=1 count=3 status=none`

if [ "$HEADER" == "BZh" ]; then
	/system/multipart_extract $3 file $4 | bzip2 -d | tar -xo -C $TMPDIR
else
        /system/multipart_extract $3 file $4 | tar -xo -C $TMPDIR
fi

rm $3

#echo "Archive extracted" 1>&2

#killall controld
/etc/init.d/m1k2 stop

if [ $1 -ne 0 ]
then
  #echo "Replacing configuration" 1>&2
  rm -rf /config/*
  mv $TMPDIR/config/* /config/
#  /etc/init.d/S30fpga stop
fi

if [ $2 -ne 0 ]
then
  #echo "Replacing profiles" 1>&2
  rm -rf /user/*
  mv $TMPDIR/user/* /user/
fi

rm -rf $TMPDIR

sync; sync; sync

#echo "Rebooting" 1>&2
reboot
shutdown -r now

#/system/fpga_off.sh
#/system/fpga_on.sh
#sleep 2
#/etc/init.d/m1k2 start


exit 0
