#!/bin/sh

cd /tmpdata/upgrade || exit 1

if [ ! -e /etc/init.d/bootmisc ]; then
    echo "This update is for mkII (black) M.1k2s only! Aborting..";
    exit 0;
fi

echo -n "Stopping services.."
if [ -e /etc/boot/m1k2.stop ]; then
    /etc/boot/m1k2.stop
else
    /etc/init.d/m1k2 stop
fi
echo " done"

mount /dev/mmcblk0p2 /boot
BOOTSIGNATURE=`md5sum /boot/imx28-m1k2.dtb | colrm 33`
if [ $BOOTSIGNATURE =   "eab089e3ea5604fe072990dd6c1d821a" ]; then
    VARIANTOSC="1"
elif [ $BOOTSIGNATURE = "7e1fd5e8ebdfc7d841d8675488d8837c" ]; then
    VARIANTOSC="1"
elif [ $BOOTSIGNATURE = "00a485de4e513be89d2894fb2a03a5f9" ]; then
    VARIANTOSC="1"
else
    VARIANTOSC="0"
fi

rm -rf /root/src

echo -en "\nUpdating system.."
rm -r /www/*
bzip2 -c -d upgrade.tar.bz2 | tar -xoC / 
echo " done"

mkdir /config/0/scripts

mknod -m 644 /dev/mtd1    c 90 1
mknod -m 644 /dev/mtd1    c 90 2
mknod -m 644 /dev/mtdblock1 b 31 1

# check last state of templog
mount /dev/mmcblk0p5 /mnt
A=`wc -c /mnt/templog | cut -d' ' -f1`
B=`wc -c /static/templog | cut -d' ' -f1`
if [ $A \> $B ]; then
    cp /mnt/templog /static_archive/static/
    cp /mnt/templog /static
else
    cp /static/templog /static_archive/static/
fi;
umount /mnt

if [ $VARIANTOSC -eq "1" ]; then
    rm /boot/imx28-m1k2_no_OSC.dtb
else
    mv /boot/imx28-m1k2_no_OSC.dtb /boot/imx28-m1k2.dtb
fi    

rm /system/plugins/*
rm /system/daemons/telnet*
rm /system/daemons/donet*

echo -e "\nRestarting.."

sync; sync; sync

reboot

exit 0
