/**
 * Port configuration
 * @copyright D.O.TEC
 * @author Florian Faber, florian.faber@directout.eu
 * @version 2 (21.10.2012)
 **/


function esc_gpo(gpo, level) {
	document.getElementById('gpo'+gpo).checked = (level==1);
	document.getElementById('igpo'+gpo).src = "/img/status_led_"+((level==0)?0:3)+".png";
} 

function esc_gpo_automation(gpo, event) {
	set_selectactive(document.getElementById('gpo'+gpo+'_event'), event);
}

function esc_gpo_polarity(gpo, polarity) {
	document.getElementById('gpo'+gpo+'_polarity').checked = (polarity==1);
}

function esc_blink_unsaved(val) {
	document.getElementById("cb_blink_unsaved").checked = (val==1);
}

function esc_state_idle(val) {
	document.getElementById("cb_state_idle").checked = (val==1);
}

function esc_identify(val) {
	document.getElementById("cb_identify").checked = (val==1);
}

function esc_device_master_ip(val) {
		document.getElementById("master_ip").value = val;
		document.getElementById("btn_activate_dg").disabled = (val=="0.0.0.0");
}

function esc_silent_mode(mode) {
		document.getElementById("silent_mode").checked = (mode==1);
}

function esc_disable_ip_reset(val) {
		document.getElementById("ip_reset").checked = (val==1);
}

function esc_disable_password_reset(val) {
		document.getElementById("password_reset").checked = (val==1);
}

function esc_auto_57ch(val) {
		document.getElementById("auto_57ch").checked = (val==1);
}

function esc_subcode(port, mode) {
		document.getElementById("subcode_"+port).checked = (mode==1);
}

var dg_own_ip = parent.frames[0].config_master_ip;

function update_dg() {
		var slaves = parent.frames[0].slaves.length;

		var t = document.getElementById('slave_list');
		while (t.hasChildNodes())
				t.removeChild(t.firstChild);
		
		if (slaves>0) {
				document.getElementById("btn_activate_dg").disabled = true;
				document.getElementById("btn_slave_active_note").style.display = "block";
				document.getElementById("no_slaves_note").style.display = "none";

				var row = t.insertRow(0);
				var th = document.createElement('th');
				th.innerHTML = "IP Address";
				row.appendChild(th);

				for (var i=0; i<slaves; i++) {
						row = t.insertRow();
						if ((i%2)==0) {
								row.className = "odd";
						}
						var td = row.insertCell(0);
						td.innerHTML = "<a href='http://"+parent.frames[0].slaves[i]+"' target='_blank'>"+parent.frames[0].slaves[i]+"</a>";
				}
						
		} else {
				document.getElementById("btn_activate_dg").disabled = ((parent.frames[0].config_master_ip=="0.0.0.0") || (parent.frames[0].config_master_ip==dg_own_ip));
				document.getElementById("btn_slave_active_note").style.display = "none";
				document.getElementById("no_slaves_note").style.display = "block";

		}
}

function dg_check_ip(tf) {
		if (tf.value!=dg_own_ip) { 
				if (/^(([1-9]?\d|1\d\d|25[0-5]|2[0-4]\d)\.){3}([1-9]?\d|1\d\d|25[0-5]|2[0-4]\d)$/.test(tf.value)) { 
						tf.style.backgroundColor = "#ffffff";
						send_cmd("master_ip?"+tf.value); 
				} else { 
						tf.style.backgroundColor = "#ff0000";
						document.getElementById("btn_activate_dg").disabled = true;
						alert("Please enter a correct IP address!"); 
				} 
		} else { 
				tf.style.backgroundColor = "#ff0000";
				document.getElementById("btn_activate_dg").disabled = true;
				alert("You cannot slave to yourself!"); 
		} 
		tf.focus();
}


function ess_slave(ip) { update_dg(); }
function ess_slave_added(ip) { update_dg(); }
function ess_slave_removed(ip) { update_dg(); }
function ess_slave_vanished(ip) { update_dg(); alert("Connection with slave "+ip+" lost!"); }


//function esc_device_mirror_data(val) {
//		document.getElementById("mirror_sync_user").checked = (val>0);
//}


function relocate(ip) {
		alert("You will now be forwared to http://"+ip);
		parent.location = "http://"+ip+"/index.html";
}


function update_network_list(response) {
  var t = document.getElementById('table_networks');
  while (t.hasChildNodes())
    t.removeChild(t.firstChild);
  
  var rows = response.split('\n');
  for (var i=0; i<rows.length; i++) {
    var line = rows[i].split(';', 3);
    if (line[1]) {
      var row = t.insertRow(i);
      if (parent.frames[0].settings_network==line[0]) {
					row.className = 'setting_active';
					dg_own_ip = line[1];
			}
      
      var td = row.insertCell(0);
      td.innerHTML = line[2];
      td.style.width = "80%";
     
      if (parent.frames[0].permissions.config_device_select_network) {
	td = row.insertCell(1);
	if (parent.frames[0].settings_network!=line[0]) {
	  td.innerHTML = "<button onclick=\"send_cmd('activate_network?"+line[0]+"'); relocate('"+line[1]+"')\");'>Activate</button>";
	}
      }
      
      if (parent.frames[0].permissions.config_device_change_network) {
	td = row.insertCell(2);
	if (line[0]==0) {
	  td.innerHTML = "<button onclick='parent.frames[1].location=\"/en/config/network.html?"+line[0]+"\";'>View</button>";
	} else {
	  td.innerHTML = "<button onclick='parent.frames[1].location=\"/en/config/network.html?"+line[0]+"\";'>Edit</button>";
	}
	
	td = row.insertCell(3);
	td.innerHTML = "<button onclick=\"ajax_call('/data/clone_network?"+line[0]+"', update_network_list);\">Clone</button>";
	
	td = row.insertCell(4);
	if ((parent.frames[0].settings_network!=line[0]) && (line[0]!=0)) {
	  td.innerHTML = "<button onclick=\"if (confirm('Are you sure to to delete this network profile?')) ajax_call('/data/delete_network?"+line[0]+"', update_network_list);\" style='background-color: red;'>Delete</button>";
	}
      }
    }
  }
}



// eventsource callbacks

function set_network(id) {
}

function set_name(str) {
	o = document.getElementById('device_name');
	if (o)
	  o.value = str;
}

function set_contact(str) {
	o = document.getElementById('device_contact');
	if (o)
	  o.value = urldecode(str);
}

function esc_plugin_perms(pluginid, permissionid) {
	var s = document.getElementById('pp_'+pluginid);
	if (s)
		set_selectactive(s, permissionid);
}

function esc_plugin_active(pluginid, status) {
	var s = document.getElementById('cb_'+pluginid);
	if (s) {
			s.checked = (status==1);
	}
}


function pp_update() {
		var all_disabled = 1;
		for (var idx in pp_serial_ids) {
				var enabled = document.getElementById('cb_'+pp_serial_ids[idx]).checked;
				if (enabled) {
						all_disabled = 0;
						for (var idx2 in pp_serial_ids) {
								if (pp_serial_ids[idx2]!=pp_serial_ids[idx]) {
										var o = document.getElementById('cb_'+pp_serial_ids[idx2]);
										o.disabled = true;
										o.title = "Disabled by "+pp_serial_names[idx]+" plugin";
								}
						}
				}
		}
		if (all_disabled) {
				for (var idx in pp_serial_ids) {
						var o = document.getElementById('cb_'+pp_serial_ids[idx]);
						o.disabled = false;
						o.title = "";
				}
		}
}

function pp_change(pluginid, permissionid) {
	ajax_call('/data/plugin_perm?'+pluginid+','+permissionid);
}

function pp_activate(pluginid) {
		var o = document.getElementById('cb_'+pluginid);
		if (o) {
				if (o.checked) {
						ajax_call('/data/plugin_activate?'+pluginid);
				} else {
						ajax_call('/data/plugin_deactivate?'+pluginid);
				}
				pp_update();
		}
}

function server_connection(res) {
	document.body.style.cursor = 'default';
	var o = document.getElementById("server_connection");
	o.innerHTML = res;
	if (res=="OK") {
		o.style.backgroundColor="green";
		var o = document.getElementById("update_div");
		o.innerHTML = "<iframe src='/update_online' width='500px' height='200px' name='update_log'></iframe><center><button onclick='ajax_call(\"/reboot\", false);'>Reboot</button></center>";	} else {
		o.style.backgroundColor="red";
	}
}


function online_update() {
	document.body.style.cursor = 'wait';
	var o = document.getElementById("server_connection");
	o.innerHTML = "Testing..";
	o.style.backgroundColor="yellow";
	ajax_call("/check_connection", server_connection);			
}


//


var pp_ids = [2,3,5,6,9,10,11,12,13,14,15,16,17];
var pp_serial_ids = [9,10,11,12,16];
var pp_serial_names = ["Jupiter", "Telnet (serial)", "SW-P 08 (serial)", "DONet (serial)", "SW-P 02 (serial)"];

function update_plugin_permissions(response) {
	for (var idx in pp_ids) {
			var s = document.getElementById('pp_'+pp_ids[idx]);
			if (s) {
					while (s.length>0) 
							s.remove();
			}
	}

	var data = JSON.parse(response);

	for (var i=0; i<data.perms.length; i++) {
    for (var idx in pp_ids) {
	  	var o = document.createElement('option');
		  o.value = data["perms"][i]["id"];
		  o.text = data["perms"][i]["name"];
			var s = document.getElementById('pp_'+pp_ids[idx]);
				if (s) {
						s.add(o);
				}
	  }
  }
	
  for (var idx in pp_ids) {
		esc_plugin_perms(pp_ids[idx], parent.frames[0].plugin_perms[pp_ids[idx]]);
  }
}


//


function permissions_updated() {
		if (!parent.frames[0].permissions)
				return;

  document.getElementById("label_name").className = (parent.frames[0].permissions.config_device_name==0)?"disabled":"";
  document.getElementById("device_name").disabled = (parent.frames[0].permissions.config_device_name==0);
  
  document.getElementById("label_contact").className = (parent.frames[0].permissions.config_device_contact==0)?"disabled":"";
  document.getElementById("device_contact").disabled = (parent.frames[0].permissions.config_device_contact==0);
  
  for (var i=0; i<4; i++) {
    document.getElementById("label_gpo"+i).className = (parent.frames[0].permissions.gpo[i]==0)?"disabled":"";
    document.getElementById("label_gpo"+i+"_inverted").className = (parent.frames[0].permissions.gpo[i]==0)?"disabled":"";
    document.getElementById("gpo"+i).disabled = (parent.frames[0].permissions.gpo[i]==0);
    document.getElementById("gpo"+i+"_event").disabled = (parent.frames[0].permissions.gpo[i]==0);
    document.getElementById("gpo"+i+"_polarity").disabled = (parent.frames[0].permissions.gpo[i]==0);
    document.getElementById("label_gpo"+i+"_inverted").className = (parent.frames[0].permissions.gpo[i]==0)?"disabled":"";
  }
  
  document.getElementById("fan").className = (parent.frames[0].permissions.config_device_fan==0)?"disabled":"";
  document.getElementById("temp_slow").disabled = (parent.frames[0].permissions.config_device_fan==0);
  document.getElementById("temp_slow_f").disabled = (parent.frames[0].permissions.config_device_fan==0);
  document.getElementById("temp_full").disabled = (parent.frames[0].permissions.config_device_fan==0);
  document.getElementById("temp_full_f").disabled = (parent.frames[0].permissions.config_device_fan==0);
  document.getElementById("temp_critical").disabled = (parent.frames[0].permissions.config_device_fan==0);
  document.getElementById("temp_critical_f").disabled = (parent.frames[0].permissions.config_device_fan==0);
  
  document.getElementById("label_blink_unsaved").className = (parent.frames[0].permissions.config_device_blink==0)?"disabled":"";
  document.getElementById("cb_blink_unsaved").disabled = (parent.frames[0].permissions.config_device_blink==0);
  document.getElementById("label_state_idle").className = (parent.frames[0].permissions.config_device_blink==0)?"disabled":"";
  document.getElementById("cb_state_idle").disabled = (parent.frames[0].permissions.config_device_blink==0);
  
  document.getElementById("snapshots").className = (parent.frames[0].permissions.config_snapshots==0)?"disabled":"";
  for (var i=0; i<127; i++) {
    var o = document.getElementById('ss_ovw_'+i);
    if (o)
      o.disabled = (parent.frames[0].permissions.config_snapshots==0);
    o = document.getElementById('ss_del_'+i);
    if (o)
      o.disabled = (parent.frames[0].permissions.config_snapshots==0);
  }

  document.getElementById("label_import_label").className = (parent.frames[0].permissions.config_system_labels==0)?"disabled":"";
  document.getElementById("label_import_file").disabled = (parent.frames[0].permissions.config_system_labels==0);

  document.getElementById("update_panel").className = (parent.frames[0].permissions.config_update==0)?"config_panel disabled":"config_panel";
  document.getElementById("label_update").className = (parent.frames[0].permissions.config_update==0)?"disabled":"";
  document.getElementById("choser_update").disabled = (parent.frames[0].permissions.config_update==0);

  ajax_call('/data/permissions', update_plugin_permissions);
}


function hexdigit(d) {
	if (d<10)
		return String.fromCharCode(d+48);
	else
		return String.fromCharCode(d-10+65);
}


function hexnum(val, digits) {
	var str = "";
	var zstr = "";
	var z = Math.pow(16, digits-1);
	while (z>val) {
		zstr = "0"+zstr;
		z = z/16;
	}
	while (val>0) {
		str = hexdigit(val%16) + str;
		val = Math.floor(val/16);
	}
	return zstr+str;
}


function init_system_snapshots() {
  var t = document.getElementById('snapshots');

  while (t.hasChildNodes())
    t.removeChild(t.firstChild);

  var row = t.insertRow(0);
  row.style.backgroundColor = '#333';
  row.style.color = '#ddd';
  var th = document.createElement('th');
  th.style.textAlign = 'left';
  th.innerHTML = '# [hex]';
  row.appendChild(th);
  th = document.createElement('th');
  th.innerHTML = "Snapshot";
  th.style.textAlign = 'left';
  row.appendChild(th);
  th = document.createElement('th');
  row.appendChild(th);
  
  if (parent.frames[0].permissions.config_snapshots==0)
    disstr = " disabled";
  else
    disstr = "";

  for (var i=1; i<128; i++) {
    row = t.insertRow(i);
    if (i%2==0)
      row.style.backgroundColor = '#999';

    var td = row.insertCell(0);
    td.innerHTML = i+" ["+hexnum(i, 2)+"]";
    td.style.textAlign = 'right';

    td = row.insertCell(1);
		td.innerHTML = '[EMPTY]';
		td.style.opacity = '0.5';
    td.style.width = '250px';

    td = row.insertCell(2);
    row.children[2].innerHTML = "<button id='ss_ovw_"+i+"' onclick='snap_import(\""+i+",0\");'"+disstr+">Import</button>";
  }
}


function update_system_snapshots(response) {
  init_system_snapshots();
  
  var rows = response.split('\n');
  var t = document.getElementById('snapshots');

  if (parent.frames[0].permissions.config_snapshots==0)
    disstr = " disabled";
  else
    disstr = "";

  for (var i=0; i<rows.length; i++) {
		var vs = rows[i].split(';', 8);
    var row = t.children[0].children[vs[0]];
			if (row) {
					row.children[1].style.opacity = '1';
					row.children[1].style.backgroundColor = '#'+vs[5];
					row.children[1].title = urldecode(vs[7]);
					row.children[1].innerHTML = vs[6];


					row.children[2].innerHTML = "<button id='ss_ovw_"+i+"' onclick='snap_import(\""+vs[0]+",0\");'"+disstr+">Overwrite</button><button id='ss_del_"+i+"' style='background-color: red;' onclick='if (confirm(\"Really delete this system snapshot?\")) send_cmd(\"system_snapshot_delete?"+vs[0]+",0\");'"+disstr+">Delete</button>";
			}
  }
}


function update_m1k2_list(response) {
		//ar status = parent.frames[0];

		var t = document.getElementById('m1k2_list');
		while (t.hasChildNodes())
				t.removeChild(t.firstChild);
		
		var row = t.insertRow(0);
		
		var th = document.createElement('th');
		th.innerHTML = "Name";
		row.appendChild(th);
		th = document.createElement('th');
		th.innerHTML = "IP Address";
		row.appendChild(th);
		th = document.createElement('th');
		row.appendChild(th);

		var data = JSON.parse(response);
		
		j=1;
		for (var i=0; i<data.length; i++) {
				if (data[i]["model"]=="M.1k2") {
						row = t.insertRow(j);
						if ((j%2)==0) {
								row.className = "even";
						} else {
								row.className = "odd";
						}
						var td = row.insertCell(0);
						td.innerHTML = data[i]["name"];
						td = row.insertCell(1);
						td.innerHTML = "<a href='http://"+data[i]["ipv4"]+"' target='_blank'>"+data[i]["ipv4"]+"</a>";
						td = row.insertCell(2);
						if (data[i]["ipv4"]!=parent.frames[0].status_ipaddr) {
								var k;
								for (k=0; k<parent.frames[0].slaves.length; k++) {
										if (parent.frames[0].slaves[k]==data[i]["ipv4"]) {
												td.innerHTML = "<i>(slave to this device)</i>";
												j++;
												break;
										}
								}
								
								if (k==parent.frames[0].slaves.length) {
										td.innerHTML = "<button onclick='document.getElementById(\"master_ip\").value=\""+data[i]["ipv4"]+"\"; send_cmd(\"master_ip?"+data[i]["ipv4"]+"\");'>Use as Master</button>";
								}
						} else {
								row.style.color = '#666';
								td.innerHTML = "<i>(this device)</i>";
						}
						j++;
				}
		}

		var b = document.getElementById('btn_refresh');
		if (b) {
				b.disabled = false;
		}

		update_dg();
}


function system_snapshots_updated() {
	var o = document.getElementById('snapshot_import');
	if (o)
		dialog_close('snapshot_import');

	ajax_call('/data/system_snapshots?0', update_system_snapshots);
}


//


function config_device_init() {
    if (parent.frames[0].status_controller>1) {
				document.getElementById("compatibility_panel").style.display = "block";
				document.getElementById("snmp_row").style.display = "table-row";
				pp_ids = [2,3,5,6,9,10,11,12,13,14];
    } else {
				document.getElementById("snmp_row").style.display = "none";
				pp_ids = [2,3,5,6,9,10,11,12,14];
		}
		
		system_snapshots_updated();
		// fan
		esc_fan(parent.frames[0].config_temps[0], parent.frames[0].config_temps[1], parent.frames[0].config_temps[2]);
		ess_temp(parent.frames[0].status_temp*1000);
		ess_fan(parent.frames[0].status_fan);
		document.getElementById('fangraph').onmousemove=fan_drag;
		document.getElementById('fangraph').onmouseup=fan_drag_off;
		esc_silent_mode(parent.frames[0].config_silent_mode);

	// gpo
	for (i=0; i<4; i++) {
		esc_gpo(i, parent.frames[0].config_gpo[i]);
		esc_gpo_automation(i, parent.frames[0].config_gpo_automation[i]);
		esc_gpo_polarity(i, parent.frames[0].config_gpo_polarity[i]);
	}

	//
	set_name(parent.frames[0].settings_name);
	set_contact(parent.frames[0].settings_contact);
	
	//

	esc_blink_unsaved(parent.frames[0].config_blink_unsaved);
	esc_state_idle(parent.frames[0].config_state_idle);
	esc_identify(parent.frames[0].config_identify);

		// doppelgaenger

		esc_device_master_ip(parent.frames[0].config_master_ip);
		//esc_device_mirror_data(parent.frames[0].config_mirror_data);
		
		// hardening

		esc_disable_ip_reset(parent.frames[0].config_ip_reset);
		esc_disable_password_reset(parent.frames[0].config_password_reset);
		
		// quirks & compatibility
		
		esc_auto_57ch(parent.frames[0].config_auto_57ch);

		for (var i=0; i<16; i++)
				esc_subcode(i, parent.frames[0].config_subcode[i]);
		
	ajax_call('/data/networks', update_network_list);

	init_system_snapshots();
	
  expand_init('config_profile');
  
	permissions_updated();

  for (var idx in pp_ids) {
		esc_plugin_active(pp_ids[idx], parent.frames[0].plugin_active[pp_ids[idx]]);
  }

		pp_update();
	
		update_dg();
		
    ajax_call('/data/mdns_m1k2', update_m1k2_list);
}


function set_network(id) {
	ajax_call('/data/networks', update_network_list);
}


window.onload = config_device_init;
