
var eventcounter = 0;

function update_eventcounter() {
  var ec = document.getElementById("eventcounter");
  
  switch (eventcounter) {
  case 0:
    ec.innerHTML = "No events logged.";
    break;
  case 1:
    ec.innerHTML = "1 event logged.";
    break;
  default:
    ec.innerHTML = eventcounter+" events logged.";
  }
}

var lastnode = false;


function clear_events() {
  var vp = document.getElementById("log");
  
	lastnode = false;

  while (vp.hasChildNodes())
    vp.removeChild(vp.children[0]);
  
  eventcounter = 0;
  update_eventcounter();
}


function filter_events() {
  var vp = document.getElementById("log");
  var d, i, type;
  
  for (i=0; i<vp.childElementCount; i++) {
    d = vp.children[i];
    type = d.className.substring(4);
    d.style.display = (document.getElementById('cb_'+type).checked)?"block":"none";
  }
}


function get_timestamp(d) {
  return d.getFullYear()+"-"+((d.getMonth()<9)?'0':'')+(d.getMonth()+1)+"-"+((d.getDate()<10)?'0':'')+d.getDate()+" "+((d.getHours()<10)?'0':'')+d.getHours()+":"+((d.getMinutes()<10)?'0':'')+d.getMinutes()+":"+((d.getSeconds()<10)?'0':'')+d.getSeconds();
}


function add_log(str, type) {
  var vp = document.getElementById("log");
  if (!vp) 
    return;
  
  var newline = document.createElement('div');
  
  var cb = document.getElementById("cb_"+type);
  if (!cb)
    throw "Unknown event type '"+type+"'";
  else {
    if (!cb.checked)
      newline.style.display = 'none';
  }

  newline.className = 'log_'+type;
  newline.innerHTML = "<span class='date'>"+get_timestamp(new Date())+"</span>"+str;
  
  if (lastnode) 
    vp.insertBefore(newline, lastnode);
  else
    vp.appendChild(newline);
  
  lastnode = newline;
  
  eventcounter++;
  update_eventcounter();
}

