/**
 * M1k2 mini eventsource
 * @copyright Florian Faber, florian.faber@directout.eu
 * @version 1 (18.11.2012) 
 **/

var connected = 0;

sync_states = ["No signal", "Lock", "??", "Sync"];
wck_sources = ["Port 1", "Port 2", "Port 3", "Port 4",
	       "Port 5", "Port 6", "Port 7", "Port 8",
	       "Port 9", "Port 10", "Port 11", "Port 12",
	       "Port 13", "Port 14", "Port 15", "Port 16",
	       "WCK Input", "Video 44.1kHz", "Video 48kHz", "Internal 44.1kHz",
	       "Internal 48kHz"];
fs_strings = ["1FS", "2FS", "4FS"];

status_port_freq = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
status_port_sync = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
status_port_mode = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
status_port_frame = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
status_port_t = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
config_port_input_redundancy = Array(16);
status_video_mode = 0;
status_temp = 0;
status_fan = 0;
status_psu = [ 0, 0 ];
status_key = 0;
status_board = 0;
status_serial = 0;
status_io_ports = [ [0, 0, 0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0, 0, 0]];
status_io_present = [0, 0];
status_io_power = [0, 0];
status_io_serial = [0, 0];
status_firmware = [ 0, 0, 0 ];
status_dead_channels = "";
status_hwaddr = "";
status_polysync = 0;
status_usage = [0, 0];

config_poly_source = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
config_wck_mul = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
config_wck_pll = -1;
config_master_enable_clock = 0;
config_master_enable_fs = 0;
config_port_mode = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
config_port_frame = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
config_port_input_redundancy = [ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 ];
config_port_output_redundancy = [ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 ];
config_port_follow = [ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 ];
config_gpo = [ 0, 0, 0, 0 ];
config_gpo_automation = [ 0, 0, 0, 0 ];
config_gpo_polarity = [ 0, 0, 0, 0 ];
config_term = 0;
config_xpo = Array(1024);
config_xpa = Array(1024);
config_lock = Array(1024);
config_gain_lock = Array(1024);
config_gains = Array(1024);
config_midi = Array(18);
config_ser = Array(20);
config_serbaud = Array(4);
config_temps = [0, 0, 0];
config_blink_unsaved = 0;
config_state_idle = 0;
config_msg_level = 0;
config_rs4xx_mode = 0;
config_rs485_echo = 0;
config_slot_power = Array(2);
config_portgains = Array(16);
config_portgain_modes = Array(16);

settings_profile = 0;
settings_network = 0;
settings_name = "";
settings_contact = "";

labels_audio_in = Array(1024);
labels_audio_in_bg = Array(1024);
labels_audio_in_fg = Array(1024);
labels_audio_out = Array(1024);
labels_audio_out_bg = Array(1024);
labels_audio_out_fg = Array(1024);
labels_serial_in = Array(20);
labels_serial_in_bg = Array(20);
labels_serial_in_fg = Array(20);
labels_serial_out = Array(20);
labels_serial_out_bg = Array(20);
labels_serial_out_fg = Array(20);
labels_midi_in = Array(18);
labels_midi_in_bg = Array(20);
labels_midi_in_fg = Array(20);
labels_midi_out = Array(18);
labels_midi_out_bg = Array(20);
labels_midi_out_fg = Array(20);
labels_input_ports = Array(18);
labels_input_ports_bg = Array(20);
labels_input_ports_fg = Array(20);
labels_output_ports = Array(18);
labels_output_ports_bg = Array(20);
labels_output_ports_fg = Array(20);

gain_sel = Array(1024);
portgain_sel = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];

scripting_system_tally = Array(64);

myname = "";

data_initialized = false;


function update_myname(name) {
  myname = name;
}


function get_effective_source(port) {
  if (config_master_enable_clock)
    return config_poly_source[17];
  
  if (port<16) {
    if ((config_port_output_redundancy[port]!=-1) && (config_port_output_redundancy[port]!=port))
      port = config_port_output_redundancy[port];
    else if ((config_port_follow[port]!=-1) && (config_port_follow[port]!=port))
      port = config_port_follow[port];
  } else {
    if ((config_port_follow[port]!=-1) && (config_port_follow[port]!=port))
      port = config_port_follow[port];
  }
  
  return config_poly_source[port];
}


function get_effective_mul(port) {
  if (config_master_enable_fs)
    return config_wck_mul[17];
  
  if (port<16) {
    if ((config_port_output_redundancy[port]!=-1) && (config_port_output_redundancy[port]!=port)) 
      port = config_port_output_redundancy[port];
    else if ((config_port_follow[port]!=-1) && (config_port_follow[port]!=port))
      port = config_port_follow[port];
  } else {
    if ((config_port_follow[port]!=-1) && (config_port_follow[port]!=port))
      port = config_port_follow[port];
  }
  
  return config_wck_mul[port];
}


function get_effective_outputmode(port) {
  if ((config_port_output_redundancy[port]!=-1) && (config_port_output_redundancy[port]!=port))
    port = config_port_output_redundancy[port];
  
  return config_port_mode[port];
}


function get_effective_outputframe(port) {
  if ((config_port_output_redundancy[port]!=-1) && (config_port_output_redundancy[port]!=port))
    port = config_port_output_redundancy[port];
  
	var m = get_effective_mul(port);
	var f = config_port_frame[port];

	if ((get_effective_mul(port)==1) && (config_port_frame[port]==96))
		return 96;
	else
		return 48;
}


function get_redundancy_status(port) {
  if (config_port_input_redundancy[port]==port)
    return -1; // no redundancy
  
  if ((status_port_sync[port]==0))
    return 1; // no signal
  
  if ((status_port_sync[port]!=3) || (status_port_sync[config_port_input_redundancy[port]]!=3))
    return 2; // no sync
  
  if (get_effective_source(port) != get_effective_source(config_port_input_redundancy[port]))
    return 3; // 3: clock reference differs
  
  if (get_effective_mul(port) != get_effective_mul(config_port_input_redundancy[port]))
    return 4; // wck mul differs
  
  if (status_port_mode[port] != status_port_mode[config_port_input_redundancy[port]])
    return 5; // incoming frame mode differs
  
  if (status_port_frame[port] != status_port_frame[config_port_input_redundancy[port]])
    return 6; // incoming frame format differs
  
  return 0; // we're happy :)
}


function verbose_redundancy_check(val) {
  switch (val) {
  case -1: return "No redundancy configured";
  case 0: return "OK";
  case 1: return "No signal";
  case 2: return "No sync";
  case 3: return "Clock reference differs";
  case 4: return "Speed mode differs";
  case 5: return "Different incoming frame mode";
  case 6: return "Different incoming frame format";
  }
}


function t_02d(v) {
  if (v<10) 
    return '0'+v;
  return v;
}


function t_str(t) {
  if (t>3600) {
    return Math.floor(t/3600) + "h" + t_02d(Math.floor((t%3600)/60)) + "'" + t_02d(Math.floor(t%60)) + '"'; 
  } else if (t>60) {
    return Math.floor(t/60) + "'" + t_02d(Math.floor(t%60)) + '"'; 
  } else {
    return Math.floor(t%60) + '"'; 
  }
}


function status_sync_str(id) {
  var t = status_port_t[id];
  if (status_port_t[id]>10) 
    return sync_states[status_port_sync[id]]+" for "+t_str(new Date().getTime()/1000-status_port_t[id]);
  
  return "No signal since last boot.";
}


function io_board_active(id) {
	return (status_io_present[id] && status_io_power[id]);
}



/**
 * 
 * EventSource callbacks
 *
 **/


function ess_key_valid(val) {
  status_key = val;

  if (this['cb_ess_key_valid'])
    cb_ess_key_valid(val);
}


function ess_board(id) {
  status_board = id;

  if (this['cb_ess_board'])
    cb_ess_board(id);
}


function ess_serial(serial) {
  status_serial = serial;

  if (this['cb_ess_serial'])
    cb_ess_serial(serial);
}

function ess_firmware(major, minor, build) {
  status_firmware[0] = major;
  status_firmware[1] = minor;
  status_firmware[2] = build;

  if (this['cb_ess_firmware']) 
    cb_ess_firmware(major, minor, build);
}


function ess_io(id, serial, p1, p2, p3, p4, p5, p6, p7, p8) {
  status_io_serial[id] = serial;

  status_io_ports[id][0] = p1;
  status_io_ports[id][1] = p2;
  status_io_ports[id][2] = p3;
  status_io_ports[id][3] = p4;
  status_io_ports[id][4] = p5;
  status_io_ports[id][5] = p6;
  status_io_ports[id][6] = p7;
  status_io_ports[id][7] = p8;
	
  if (this['cb_ess_io']) {
    cb_ess_io(id, serial, p1, p2, p3, p4, p5, p6, p7, p8);
  }
}


function ess_io_present(id, p) {
  status_io_present[id] = p;

  if (this['cb_ess_io_present'])
    cb_ess_io_present(id, p);
}


function ess_io_power(id, p) {
  status_io_power[id] = p;

  if (this['cb_ess_io_power'])
    cb_ess_io_power(id, p);
}


function ess_psu(id, s) {
	status_psu[id] = s;

  if (this['cb_ess_psu']) {
    cb_ess_psu(id, s);
  }
}


function update_temp() {
  var img = document.getElementById("temp");
  if (img) {
    if (status_temp>=config_temps[2]) {
      img.src = "/img/status_temp_3.png";
    } else if (status_temp>=config_temps[1]) {
      img.src = "/img/status_temp_2.png";
    } else if (status_temp>=config_temps[0]) {
      img.src = "/img/status_temp_1.png";
    }
    img.title = status_temp+"\u00B0C";
  }	
}


function ess_temp(temp) {
  status_temp = Math.floor(temp/100)/10;

  update_temp();

  if (this['cb_ess_temp']) {
    cb_ess_temp(status_temp);
  }
}


function ess_fan(speed) {
  status_fan = speed;

  if (this['cb_ess_fan']) {
    cb_ess_fan(speed);
  }
}


function ess_freq(port, freq) {
  status_port_freq[port] = freq;

  if (port<16)
    update_incoming(port);
  else if (port==16) {
    update_wck_in();
    update_wck_out();
  } else if ((port==17) || (port==18)) 
    update_video();
  else if (port==19)
    update_wck_out();
}


function ess_port_mode(port, mode) {
  status_port_mode[port] = mode;

  if (this['cb_ess_port_mode']) {
    cb_ess_port_mode(port, mode);
  }

  check_redundancy();
}


function ess_port_frame(port, frame) {
  status_port_frame[port] = frame;

  if (this['cb_ess_port_frame']) {
    cb_ess_port_frame(port, frame);
  }

  check_redundancy();
}


function ess_sync(port, sync, t) {
  status_port_sync[port] = sync;
  status_port_t[port] = new Date().getTime()/1000 - t;

  if (port<16)
    check_redundancy();

  if (this['cb_ess_sync']) {
    cb_ess_sync(port, sync, t);
  }
}


function ess_video_mode(mode) {
  status_video_mode = mode;

  if (this['cb_ess_video_mode']) {
    cb_ess_video_mode(mode);
  }
}


function ess_dead_channels(channels) {
  status_dead_channels = channels;

  if (this['cb_ess_dead_channels'])
    cb_ess_dead_channels(channels);
}


function ess_hwaddr(str) {
  status_hwaddr = str;
}


function ess_polysync(p) {
	status_polysync = p;

  if (this['cb_ess_polysync']) {
    cb_ess_polysync(p);
  }
}


function ess_usage(fs, usage) {
	status_usage[fs] = usage;

  if (this['cb_ess_usage']) {
    cb_ess_usage(fs, usage);
  }
}


//
//
//


function esc_master_enable_clock(enable) {
  config_master_enable_clock = enable;
  
  //update_wck();
  
  update_master_clock();
  update_wck_out();
  update_port_clocks();

  check_redundancy();
}


function esc_master_enable_fs(enable) {
  config_master_enable_fs = enable;
  
  update_master_fs();
  update_wck_out();
  update_fs();

  check_redundancy();
}


function esc_xp(m, ch_in, ch_out) {
  var old = -1;
  if (m==0) {
    old = config_xpa[ch_out];
    config_xpa[ch_out] = ch_in;

  } else if (m==1) {
    old = config_xpo[ch_out];
    config_xpo[ch_out] = ch_in;
  }

  if (old>-1) {
    if (this['cb_remove_xp']) {
      cb_remove_xp(m, old, ch_out);
    }
  }

  if (this['cb_esc_xp']) {
    cb_esc_xp(m, ch_in, ch_out);
  }
}


function esc_al(ch, val) {
  config_lock[ch] = val;

  if (this['cb_esc_al'])
    cb_esc_al(ch, val);
}


function esc_gl(ch, val) {
  config_gain_lock[ch] = val;

  if (this['cb_esc_gl'])
    cb_esc_gl(ch, val);
}


function esc_gain(ch, gain) {
  config_gains[ch] = gain;

  if (this['cb_esc_gain'])
    cb_esc_gain(ch, gain);
}


function esc_midixp(p_in, p_out) {
  config_midi[p_out] = p_in;

  if (this['cb_esc_midixp']) {
    cb_esc_midixp(p_in, p_out);
  }
}


function esc_serxp(p_in, p_out) {
  config_ser[p_out] = p_in;

  if (this['cb_esc_serxp']) {
    cb_esc_serxp(p_in, p_out);
  }
}

function esc_serbaud(p, baud) {
  config_serbaud[p] = baud;

  if (this['cb_esc_serbaud']) {
    cb_esc_serbaud(p, baud);
  }
}


function esc_poly_source(port, source) {
  config_poly_source[port] = source;

  check_redundancy();

	//update_wck();

  if (this['cb_esc_poly_source']) {
    cb_esc_poly_source(port, source);
  }
}

function esc_wck_mul(port, mul) {
  config_wck_mul[port] = mul;

  check_redundancy();

  if (port==16)
    update_wck_out();
  else if (port==17)
    update_master_fs();
  else
    update_moni(port);
  
  update_outgoing();
  update_fs();
}

function esc_wck_pll(val) {
  config_wck_pll = val;

  if (this['cb_esc_wck_pll']) 
    cb_esc_wck_pll(val);
}

function esc_port_mode(port, mode) {
  config_port_mode[port] = mode;
	
  if (this['cb_esc_port_mode']) {
    cb_esc_port_mode(port, mode);
  }
}

function esc_port_frame(port, frame) {
  config_port_frame[port] = frame;

  if (this['cb_esc_port_frame'])
    cb_esc_port_frame(port, frame);
}

function esc_port_input_redundancy(port, redundancy) {
  config_port_input_redundancy[port] = redundancy;

  if (this['cb_esc_port_input_redundancy'])
    cb_esc_port_input_redundancy(port, redundancy);
}

function esc_port_output_redundancy(port, redundancy) {
  config_port_output_redundancy[port] = redundancy;

  if (this['cb_esc_port_output_redundancy'])
    cb_esc_port_output_redundancy(port, redundancy);
}

function esc_port_follow(port, follow) {
  config_port_follow[port] = follow;
  
	if (this['cb_esc_port_follow'])
	  cb_esc_port_follow(port, follow);
}

function esc_gpo(gpo, level) {
  config_gpo[gpo] = level;

  if (this['cb_esc_gpo'])
    cb_esc_gpo(gpo, level);
}

function esc_gpo_automation(gpo, action) {
  config_gpo_automation[gpo] = action;

  if (this['cb_esc_gpo_automation'])
    cb_esc_gpo_automation(gpo, action);
}

function esc_gpo_polarity(gpo, pol) {
  config_gpo_polarity[gpo] = pol;

  if (this['cb_esc_gpo_polarity'])
    cb_esc_gpo_polarity(gpo, pol);
}

function esc_term(level) {
  config_term = level;

  if (this['cb_esc_term'])
    cb_esc_term(level);
}

function esc_blink_unsaved(val) {
  config_blink_unsaved = val;

  if (this['cb_esc_blink_unsaved'])
    cb_esc_blink_unsaved(val);
}

function esc_state_idle(val) {
  config_state_idle = val;
	
  if (this['cb_esc_state_idle'])
    cb_esc_state_idle(val);
}

function esc_msg_level(val) {
  config_msg_level = val;
	
  if (this['cb_esc_msg_level'])
    cb_esc_msg_level(val);
}

function esc_fan(warm, full, critical) {
  config_temps[0] = warm;
  config_temps[1] = full;
  config_temps[2] = critical;

  if (this['cb_esc_fan'])
    cb_esc_fan(warm, full, critical);
}


function esc_rs4xx_mode(val) {
  config_rs4xx_mode = val;

  if (this['cb_esc_rs4xx_mode'])
    cb_esc_rs4xx_mode(val);
}


function esc_rs485_echo(val) {
  config_rs485_echo = val;

  if (this['cb_esc_rs485_echo'])
    cb_esc_rs485_echo(val);
}


function esc_slot_power(slot, power) {
  config_slot_power[slot] = power;

  if (this['cb_esc_slot_power'])
    cb_esc_slot_power(slot, power);
}


function esc_portgain(port, gain) {
  config_portgains[port] = gain;

  if (this['cb_esc_portgain'])
    cb_esc_portgain(port, gain);
}


function esc_portgain_mode(port, mode) {
  config_portgain_modes[port] = mode;
	
  if (this['cb_esc_portgain_mode'])
    cb_esc_portgain_mode(port, mode);
}

function set_profile(id) {
  settings_profile = id;
	
  if (this['cb_set_profile'])
    cb_set_profile(id);
}

function set_network(id) {
  settings_network = id;
	
  if (this['cb_set_network'])
    cb_set_network(id);
}

function set_name(str) {
  settings_name = str;

  if (this['cb_set_name'])
    cb_set_name(settings_name);
}

function set_contact(str) {
  settings_contact = str;
	
  if (this['cb_set_contact'])
    cb_set_contact(settings_contact);
}


//


function esl(type, id, label, fg, bg) {
  switch (type) {
  case 128:
    labels_audio_in[id] = label;
    labels_audio_in_fg[id] = fg;
    labels_audio_in_bg[id] = bg;
    break;
  case 129:
    labels_audio_out[id] = label;
    labels_audio_out_fg[id] = fg;
    labels_audio_out_bg[id] = bg;
    break;
  case 130:
    labels_serial_in[id] = label;
    labels_serial_in_fg[id] = fg;
    labels_serial_in_bg[id] = bg;
    break;
  case 131:
    labels_serial_out[id] = label;
    labels_serial_out_fg[id] = fg;
    labels_serial_out_bg[id] = bg;
    break;
  case 132:
    labels_midi_in[id] = label;
    labels_midi_in_fg[id] = fg;
    labels_midi_in_bg[id] = bg;
    break;
  case 133:
    labels_midi_out[id] = label;
    labels_midi_out_fg[id] = fg;
    labels_midi_out_bg[id] = bg;
    if (id==17)
      data_initialized = true;
    break;
  case 134:
    labels_input_ports[id] = label;
    labels_input_ports_fg[id] = fg;
    labels_input_ports_bg[id] = bg;
    break;
  case 135:
    labels_output_ports[id] = label;
    labels_output_ports_fg[id] = fg;
    labels_output_ports_bg[id] = bg;
    break;
  }

  if (this['cb_esl'])
    cb_esl(type, id, label, fg, bg);
}


//


function permissions_changed() {
  if (this['cb_load_permissions'])
    cb_load_permissions();
}


//


function system_snapshots_updated() {
  if (this['cb_system_snapshots_updated'])
    cb_system_snapshots_updated();
}

function system_userbase_changed() {
  if (this['cb_system_userbase_changed'])
    cb_system_userbase_changed();
}


//
// System Scripts
//

function show_log(id) {
  window.open('/data/system_script_log?'+id, 'scriptlog', 'location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no,height=600,width=700');
}
	

function cb_logfile(res) {
		var data = res.split(',');
		var o = document.getElementById("s_log_"+data[0]);
		o.style.display = (data[1]=='y')?"block":"none";
}


var glows = [];

function btn_unglow() {
		var id = glows.shift();
		var o = document.getElementById("script_"+id);
		if (o) {
				o.style.border = o.oldborder;
				o.oldborder = null;
		}
}

function btn_glow(id, color) {
		var o = document.getElementById("script_"+id);
		if (o) {
				if (!o.oldborder)
						o.oldborder = o.style.border;
				o.style.border = "2px solid "+color;
				glows.push(id);
				setTimeout(btn_unglow, 2000);
		}
}

function run_script(e) {
		var srcElement;
		
		if (e.srcElement) {
			srcElement = e.srcElement;
		} else if (e.originalTarget) {
			srcElement = e.originalTarget;
		}		

		if (typeof(srcElement.scriptid)=="undefined")
				srcElement = srcElement.parentElement;;
		
		ajax_call('/data/run_system_script?'+srcElement.scriptid);		
}

function update_system_scripts(response) {
		var data = JSON.parse(response);

		// remove all buttons
		var container = document.getElementById('system_scripts');
		while (container.hasChildNodes())
		    container.removeChild(container.firstChild);

		var max_y = 0;
		
		for (var id=0; id<64; id++) {
        if (data[id]) {
						var y = 35+Math.floor(id/4)*70;
						if (y>max_y)
								max_y = y;
						
						var x = 20+id%4*180;
														
  					var o = document.createElement("div");
	  				o.id = "script_"+id;							
						o.className = 'scriptbutton';

						o.style.position = 'absolute';
						o.style.left = x+"px";
						o.style.top = y+"px";
						o.scriptid = id;
						o.onclick = run_script;
						o.style.backgroundColor = data[id]["bg"];
						o.style.color = data[id]["fg"];
						o.style.cursor = "pointer";
						o.title = data[id]["desc"];
						o.innerHTML = "<div id='s_log_"+id+"' style='display: none;' class='scriptlog' onclick='event.stopPropagation(); show_log("+id+");'>View log..</div><div class='script_title' id='script_title_"+id+"'>"+data[id]["name"]+"</div>";
						
						container.appendChild(o);

						ajax_call("/data/system_script_haslog?"+id, cb_logfile);
				}
		}
}

function system_scripts_updated() {
	  ajax_call('/data/system_scripts', update_system_scripts);
}

function system_script_success(id) {
		ajax_call("/data/system_script_haslog?"+id, cb_logfile);
		btn_glow(id, "#448844");
}

function system_script_error(id) {
		ajax_call("/data/system_script_haslog?"+id, cb_logfile);
		btn_glow(id, "#884444");
}



//
//
//


function events_connect() {
  document.getElementById('connecting').style.display = 'none';
}

function events_disconnect() {
  document.getElementById('connecting').style.display = 'block';
}


function bulk_xp(matrix, ar) {
  var i;
  
  for (i=0; i<1024; i++)
    esc_xp(matrix, ar[i], i);
}

function bulk_gain(ar) {
  var i;
  
  for (i=0; i<1024; i++)
    esc_gain(i, ar[i]);
}

function bulk_audio_lock(ar) {
  var i;
  
  for (i=0; i<1024; i++)
    esc_al(i, ar[i]);
}

function bulk_gain_lock(ar) {
  var i;
  
  for (i=0; i<1024; i++)
    esc_gl(i, ar[i]);
}

function bulk_label(type, ar) {
  var i;
  
  for (i=0; i<ar.length; i++)
    esl(type, i, ar[i][0], ar[i][1], ar[i][2]);
}



var dead_canvas, dead_ctx, sig_canvas, sig_ctx, sel_canvas, sel_ctx;
var dead_channels = true;
var color_grid = "rgb(0, 0, 0)";
var color_dead = "rgba(66, 66, 66, 0.4)";

//
//
//

function update_incoming(port) {
	var c = document.getElementById('port_'+port+'_incoming');
	var i = document.getElementById('sync_'+port);

	i.src = '/img/status_led_'+status_port_sync[port]+'.'+((status_port_sync[port]==1)?"gif":"png");
							       
	if (status_port_sync[port]==0) {
		c.style.color = 'red';
		c.innerHTML = 'No signal';
	} else {
		c.style.color = 'black';
		c.innerHTML = status_port_mode[port]+"ch / "+status_port_frame[port]+"kHz / "+status_port_freq[port]+"Hz";
	}
}

function update_outgoing() {
	for (var i=0; i<16; i++) {
		document.getElementById('port_'+i+'_outgoing').innerHTML = get_effective_outputmode(i)+"ch / "+get_effective_outputframe(i)+"kHz";
	}
}

function update_fs() {
	for (var i=0; i<16; i++) {
		document.getElementById('port_'+i+'_fs').innerHTML = fs_strings[get_effective_mul(i)];
	}
}

function update_port_clocks() {
	for (var i=0; i<16; i++) {
		document.getElementById('port_'+i+'_clock').innerHTML = wck_sources[get_effective_source(i)];
	}
}

function update_wck_in() {
	var c = document.getElementById('clock_wck_in');

	if (status_port_sync[16]==0) {
		c.style.color = 'red';
		c.innerHTML = '<img src="/img/status_led_0.png"> No signal.';
	} else {
		c.style.color = 'black';
		c.innerHTML = '<img src="/img/status_led_'+status_port_sync[16]+'.'+((status_port_sync[16]==1)?"gif":"png")+'> '+status_port_freq[16]+'Hz';
	}
}

function update_wck_out() {
  document.getElementById('clock_wck_out').innerHTML = '<b>'+wck_sources[get_effective_source(16)]+'</b> @ '+status_port_freq[19]+'Hz, WCK out #2 uses <b>'+fs_strings[get_effective_mul(16)]+'</b>';
}

function update_video() {
	var c = document.getElementById('clock_video');

	if (status_port_sync[17]==0) {
		c.style.color = 'red';
		c.innerHTML = '<img src="/img/status_led_0.png"> No signal.';
	} else {
		c.style.color = 'black';
		c.innerHTML = '<img src="/img/status_led_'+status_port_sync[17]+'.'+((status_port_sync[17]==1)?"gif":"png")+'> '+status_port_freq[17]+'Hz / '+status_port_freq[18]+'Hz';
	}
}

function update_master_clock() {
	if (config_master_enable_clock)
		document.getElementById('clock_master').innerHTML = 'Enabled, using <b>'+wck_sources[config_poly_source[17]]+'</b> as reference';
	else
		document.getElementById('clock_master').innerHTML = 'Disabled.';
}

function update_master_fs() {
  if (config_master_enable_fs)
    document.getElementById('clock_fs').innerHTML = 'Enabled, using <b>'+fs_strings[config_wck_mul[17]]+'</b>';
  else
    document.getElementById('clock_fs').innerHTML = 'Disabled.';
  for (var i=0; i<16; i++)
    update_moni(i); 
}


function update_channel(port, ch, sig) {
  var mul = get_effective_mul(port)+1;
  if (mul==3) 
    mul=4;

  if ((status_port_mode[port]==56) && 
      (ch >= 56)) 
    return;

  if (ch%mul!=0)
    return;

  ch = ch/mul;

  var y = port*40;
  if (ch>=(32/mul))
    y += 20;
  var x = 20*(ch%(64/(mul*2)));
	
  if (sig>0) {		
    sig_ctx.fillStyle = "rgba(0, 153, 0, 0.5)";
		//sig_ctx.fillStyle = get_sync_color(port);
    sig_ctx.fillRect(x*mul+1, y+1, 20*mul-1, 19);

  } else {
    sig_ctx.clearRect(x*mul+1, y+1, 20*mul-1, 19);
  }
}


function draw_dead_channel(port, ch, val) {
  var mul = get_effective_mul(port)+1;
  if (mul==3) 
    mul=4;

  if (ch*mul>=64)
    return;

  if ((status_port_mode[port]==56) && 
      (ch*mul >= 56)) 
    return;

  var y = port*40;
  if (ch>=(32/mul))
    y += 20;
  var x = 20*(ch%(64/(mul*2)));
	
  if (val) {		
    dead_ctx.fillRect(x*mul+1, y+1, 20*mul-1, 19);

  } else {
    dead_ctx.clearRect(x*mul+1, y+1, 20*mul-1, 19);
  }
}

function update_dead(idx, s1, s2, s3, s4) {
  var port = Math.floor(idx/16);
  var ch = idx*4-port*64;
  draw_dead_channel(port, ch, s1);
  draw_dead_channel(port, ch+1, s2);
  draw_dead_channel(port, ch+2, s3);
  draw_dead_channel(port, ch+3, s4);
}

function draw_dead_nibble(idx, nibble) {	
  switch(nibble) {
  case '0': update_dead(idx, 0, 0, 0, 0); break;
  case '1': update_dead(idx, 0, 0, 0, 1); break;
  case '2': update_dead(idx, 0, 0, 1, 0); break;
  case '3': update_dead(idx, 0, 0, 1, 1); break;
  case '4': update_dead(idx, 0, 1, 0, 0); break;
  case '5': update_dead(idx, 0, 1, 0, 1); break;
  case '6': update_dead(idx, 0, 1, 1, 0); break;
  case '7': update_dead(idx, 0, 1, 1, 1); break;
  case '8': update_dead(idx, 1, 0, 0, 0); break;
  case '9': update_dead(idx, 1, 0, 0, 1); break;
  case 'A': update_dead(idx, 1, 0, 1, 0); break;
  case 'B': update_dead(idx, 1, 0, 1, 1); break;
  case 'C': update_dead(idx, 1, 1, 0, 0); break;
  case 'D': update_dead(idx, 1, 1, 0, 1); break;
  case 'E': update_dead(idx, 1, 1, 1, 0); break;
  case 'F': update_dead(idx, 1, 1, 1, 1); break;
  }
}

function redraw_port(port) {
  var bg = document.getElementById("bg_"+port);
  if (bg)
    bg.src = "/img/moni_bg_"+get_effective_mul(port)+"_"+((status_port_sync[port]==3)?"0":"2")+".png";	
  if (last_signals) {
    for (var i=port*8; i<(port+1)*8; i++) {
      for (var j=0; j<8; j++) {
	update_channel(port, (i%8)*8+(7-j), last_signals[i]&(1<<j));
      }

      if (dead_channels) {
	draw_dead_nibble(status_dead_channels[i*2], true);
	draw_dead_nibble(status_dead_channels[i*2+1], true);
      }
    }
  }
}

function draw_grid(port) {
  var mul = get_effective_mul(port)+1;
  if (mul==3) 
    mul=4;
	
  sig_ctx.fillStyle = color_grid;
  sig_ctx.fillRect(0, port*40, 640, 1);
  sig_ctx.fillRect(0, port*40+20, 640, 1);
  sig_ctx.fillRect(0, port*40+40, 640, 1);

  for (var x=0; x<=32/mul; x++)
    sig_ctx.fillRect(x*mul*20, port*40, 1, 41);

  if (status_port_mode[port]==56) {
    sig_ctx.fillStyle = color_dead;
    sig_ctx.fillRect(481, port*40+20+1, 160, 19);
  }
}


function update_moni(port) {
  dead_ctx.clearRect(0, port*40, 640, 40);
  sig_ctx.clearRect(0, port*40, 640, 40);
  sel_ctx.clearRect(0, port*40, 640, 40);
  
  draw_grid(port);  
  redraw_port(port);	
}


//
//
//



function system_script_tally(scriptid, status) {
    scripting_system_tally[scriptid] = status;
}



function cb_ess_sync(port, sync, t) {
	if (port<16) {
		update_incoming(port);
		redraw_port(port);
	}	else if (port==17)
		update_wck_in();
	else if (port==18)
		update_video();
}

function cb_ess_port_mode(port, mode) {
	update_incoming(port);

  sig_ctx.clearRect(480, port*40+20+1, 160, 19);
  draw_grid(port);
  redraw_port(port);
}

function cb_ess_port_frame(port, frame) {
	update_incoming(port);
}

function cb_esc_port_mode(port, frame) {
	update_outgoing();
}

function cb_esc_port_frame(port, frame) {
	update_outgoing();
}

function cb_esc_poly_source(port, source) {
  if (port==16) {
    update_wck_in();
    update_wck_out();
  }	else if (port==17) {
    update_master_clock();
    update_wck_out();
  }
  
  update_port_clocks();
}

function cb_port_output_redundancy(port, redundancy) {
	update_outgoing();
	update_fs();
	update_port_clock();
}

function cb_port_follow(port, follow) {
	if (port==16)
		update_wck_out();

	update_fs();
	update_port_clock();
}

function cb_ess_temp(temp) {
	document.getElementById("dev_temp").innerHTML = temp+"\u00B0C";
}

function cb_esc_gpo(gpo, level) {
  if (level==1)
    level=3;
  document.getElementById("dev_gpo_"+gpo).src = '/img/status_led_'+level+".png";
}

function cb_ess_psu(id, s) {
  if (s==1)
    s=3;
  var img = document.getElementById("dev_psu_"+id);
  if (img)
    img.src = "/img/status_led_"+s+".png";
  
  if (s==2)
    alert("WARNING: PSU "+(id+1)+" has failed");
}

function cb_esc_term(level) {
	document.getElementById('clock_term').innerHTML = '<img src="/img/'+((level==0)?'status_led_0.png':'term_on.png')+'">';
}

function cb_set_name(name) {
	document.getElementById('dev_name').innerHTML = name;
}

function cb_set_contact(contact) {
	document.getElementById('dev_contact').innerHTML = contact;
}


var last_signals = Array(128);

function signals(data) {
  if (!last_signals) {
    for (var i=0; i<128; i++) {
      last_signals[i] = (data[i]=='0')?'1':'0';
    }
  }

  for (var i=0; i<128; i++) {
    if (data[i]!=last_signals[i]) {
      var port = Math.floor(i/8);
      for (var j=0; j<8; j++) {
	var sig = data[i]&(1<<j);
	var lsig = last_signals[i]&(1<<j);
	if ((data[i]&(1<<j)) != (last_signals[i]&(1<<j))) {
	  update_channel(port, (i%8)*8+(7-j), data[i]&(1<<j));
	}
      }
      last_signals[i] = data[i];
   }
  }
}


function cb_ess_dead_channels(channels) {
  dead_ctx.clearRect(0, 0, 640, 640);
  dead_ctx.fillStyle = color_dead;

  for (var i=0; i<256; i++) {
    draw_dead_nibble(i, channels[i]);
  }
}

//
//
//


function init_snapshots(name) {
  var t = document.getElementById(name);

  while (t.hasChildNodes())
    t.removeChild(t.firstChild);
}

function cb_snapshot_loaded(res) {
	if (res.substr(0, 2)=="OK")
		alert("Snapshot loaded");
}

function load_snapshot(e) {
	var srcElement;
	
	if (e.currentTarget) {
		srcElement = e.currentTarget;
	} else if (e.originalTarget) {
		srcElement = e.originalTarget;
	}		

  if (confirm("Really load this snapshot?"))
    ajax_call("/cmd/snapshot_recall?"+srcElement.sid+",4087", cb_snapshot_loaded);
}

function cb_snapshots(response) {
  init_snapshots('snapshots');
  var snapshots = document.getElementById('snapshots');

  var rows = response.split('\n');
	
	for (var i=0; i<rows.length; i++) {
		var vs = rows[i].split(';', 8);
		
		if (vs.length<7) {
			if (i==0) {
				snapshots.innerHTML = "You have no user snapshots.";
				var btn = document.getElementById('btn_2');
				btn.style.opacity = 0.5;
				btn.style.cursor = 'default';
			}
		} else {
			var d = document.createElement('div');
			d.className = 'snapshot';
			d.sid = vs[0];
			d.style.backgroundColor = '#'+vs[5];
			d.style.color = '#'+vs[4];
			d.style.cursor = 'pointer';
			//vs[7] = decodeURICompoment(vs[7]).replace(/^\s+|\s+$/g,"");
			vs[7] = vs[7].replace(/^\s+|\s+$/g,"");
			d.innerHTML = "<div class='title'>"+vs[6]+"</div><div class='desc'>"+vs[7]+"</div>";
			d.onclick = load_snapshot;
			
			snapshots.appendChild(d);
		}
	}
}


function load_system_snapshot(e) {
	var srcElement;
	
	if (e.currentTarget) {
		srcElement = e.currentTarget;
	} else if (e.originalTarget) {
		srcElement = e.originalTarget;
	}		
	
  if (confirm("Really load this system snapshot?"))
    ajax_call("/cmd/system_snapshot_recall?"+srcElement.ssid+",4087", cb_snapshot_loaded);
}

function cb_system_snapshots(response) {
  init_snapshots('system_snapshots');

  var snapshots = document.getElementById('system_snapshots');

  for (var i=1; i<128; i++) {
    var d = document.createElement('div');
    d.className = 'snapshot';
    d.id = 'system_snapshot_'+i;
    d.ssid = i;
    d.innerHTML = i+": [EMPTY]";
    snapshots.appendChild(d);
  }

  var rows = response.split('\n');

  for (var i=0; i<rows.length; i++) {
    var vs = rows[i].split(';', 8);

    var d = document.getElementById('system_snapshot_'+vs[0]);
    d.style.backgroundColor = '#'+vs[5];
    d.style.color = '#'+vs[4];
    d.style.cursor = 'pointer';
		vs[7] = decodeURIComponent(vs[7]).replace(/^\s+|\s+$/g,"");
		d.innerHTML = "<div class='title'>"+vs[0]+": "+vs[6]+"</div><div class='desc'>"+vs[7]+"</div>";
    d.onclick = load_system_snapshot;
  }
}


function check_redundancy() {
    for (var i=0; i<16; i++) {
				var l = document.getElementById("port_"+i+"_name");
				var s = get_redundancy_status(i);
				if (s<=0) {
						l.style.backgroundColor = '';
				} else {
						l.style.backgroundColor = 'red';
				}
    }
}


function update_snapshots() {
  ajax_call("/data/snapshots", cb_snapshots);
}

function cb_system_snapshots_updated() {
  ajax_call('/data/system_snapshots?0', cb_system_snapshots);
}


function btn_click(id) {
  document.getElementById('status').style.display = (id==0)?'block':'none';
  document.getElementById('monitoring').style.display = (id==1)?'block':'none';
  document.getElementById('snapshots').style.display = (id==2)?'block':'none';
  document.getElementById('system_snapshots').style.display = (id==3)?'block':'none';
  document.getElementById('system_scripts').style.display = (id==4)?'block':'none';
  for (i=0; i<5; i++)
    document.getElementById('btn_'+i).className = ((id==i)?"selected ":"")+"button";

  if (id==1)
    rt_connect();
  else
    rt_disconnect();
}


function init_status() {
  var t = document.getElementById('ports');
  for (i=0; i<16; i++) {
    var row = t.insertRow(i+1);
    row.className = (i%2==0)?"even":"odd";
    var c = row.insertCell(0);
    c.innerHTML = "Port "+(i+1);
    c.id = 'port_'+i+'_name';
    c = row.insertCell(1);
    c.innerHTML = '<img id="sync_'+i+'">';
    c = row.insertCell(2);
    c.id = 'port_'+i+'_incoming';
    c = row.insertCell(3);
    c.id = 'port_'+i+'_outgoing';
    c = row.insertCell(4);
    c.id = 'port_'+i+'_clock';
    c = row.insertCell(5);
    c.id = 'port_'+i+'_fs';
  }
}


function init_monitoring() {
  dead_canvas = document.getElementById('dead_canvas');
  dead_ctx = dead_canvas.getContext('2d');
  sig_canvas = document.getElementById('sig_canvas');
  sig_ctx = sig_canvas.getContext('2d');
  sel_canvas = document.getElementById('sel_canvas');
  sel_ctx = sel_canvas.getContext('2d');

  var labels = document.getElementById("moni_labels");
  var bg = document.getElementById("moni_bg");

  for (var i=0; i<16; i++) {
    var o = document.createElement("img");
    o.id = "bg_"+i;
    o.style.top = (i*40)+"px";
    bg.appendChild(o);

    o = document.createElement("div");
    o.id = "label_"+i;
    o.innerHTML = "Port "+(i+1);
    o.style.top = (i*40)+"px";
    o.className = "monilabel";
    labels.appendChild(o);
  }
}


function mobile_init() {
		if (!("WebSocket" in window)) {
				window.location = '/en/browser.html';
				return;
		}
		
		btn_click(0);
		
		
		update_snapshots();
		cb_system_snapshots_updated();
		init_status();
		init_monitoring();
		ajax_call('/data/system_scripts', update_system_scripts);											
		ws_init(events_connect, events_disconnect);
}
