var dead_canvas, dead_ctx, sig_canvas, sig_ctx, sel_canvas, sel_ctx, perm_canvas, perm_ctx;
var listen_channel, last_listen_channel=-1, channel_info, display_labels, dead_channels, last_dead;
var sync_table=Array(16);

var moni_out = { "port": 0, "channel": 0, "mode": "stereo", "gain": 0, "mute": false };
var moni_settings = { "mode": "dual", "safe": true, "distance": 1, "dim": true };

var color_grid = "rgb(0, 0, 0)";
var color_listen = "rgba(155, 255, 155, 0.9)";
var color_sel = "rgb(255, 255, 255)";
var color_blink = "rgba(255, 255, 255, 0.7)";
var color_blink_err = "rgba(255, 0, 0, 0.7)";
var color_dead = "rgba(66, 66, 66, 0.4)";
var color_disabled = "rgba(50, 50, 50, 0.7)";
var color_56ch = "rgba(80, 80, 80, 0.7)";


function get_sync_color(port) {
  switch (sync_table[port]) {
  case 0: // synchronous
    return "rgba(0, 153, 0, 0.5)";
  case 1: // probably asynchronous
    return "rgba(204, 204, 0, 0.5)";
  case 2: // asynchronous
    return "rgba(153, 0, 0, 0.5)";
	default:
		alert(sync_table[port]);
  }
}


function draw_selection_box(port, ch, color, mul) {
  if (ch*mul>=64)
    return;
  
  if ((parent.frames[0].status_port_mode[port]==56) && 
      (ch*mul >= 56)) 
    return;
  
  if (parent.frames[0].permissions.xp_in[port*64+ch]==0)
    return;

  var x = ch*mul*20;
  var y = port*40;
  
  if (ch*mul>=32) {
    x -= 640;
    y += 20;
  }
  
  if (color) {
    sel_ctx.fillStyle = color;
    sel_ctx.fillRect(x+1, y+1, 20*mul-1, 19);
    
  } else {
    sel_ctx.clearRect(x, y, 20*mul, 20);
  }
}


function get_second_channel(ch) {
	if (moni_settings["mode"]=="dual")
		return ch+moni_settings["distance"];
	else
		return ch;
}


function draw_selection(port, ch, color) {
  var mul = parent.frames[0].get_effective_mul(port)+1;
  if (mul==3) 
    mul=4;
	
  draw_selection_box(port, ch, color, mul);

  if (moni_settings["mode"]=="dual") {
    var c = get_second_channel(port*64+ch);
    draw_selection_box(Math.floor(c/64), c%64, color, mul);
    
  }
}


function update_sync_table() {
  for (var i=0; i<16; i++) {
    if (parent.frames[0].status_polysync==0) { // polysync off
      var a = parent.frames[0].get_effective_mul(i);
      var b = parent.frames[0].get_effective_mul(moni_out["port"]);
      if ((parent.frames[0].status_port_sync[i]==3) &&
					(parent.frames[0].get_effective_mul(i)==parent.frames[0].get_effective_mul(moni_out["port"]))) {
				// sync & same speed mode -> fuckin' A
				newval = 0;
				
      } else if ((parent.frames[0].status_port_sync[i]==1) &&
								 (parent.frames[0].status_port_freq[i]==parent.frames[0].status_port_freq[moni_out["port"]]) &&
								 (parent.frames[0].get_effective_mul(i)==parent.frames[0].get_effective_mul(moni_out["port"]))) {
				// lock & similar frequency & same speed mode
				newval = 1;
				
      } else {
				newval = 2;
      }
      
    } else {  // polysync on
      if ((parent.frames[0].get_effective_source(i)==parent.frames[0].get_effective_source(moni_out["port"])) &&
					(parent.frames[0].status_port_sync[i]==3) &&
					(parent.frames[0].get_effective_mul(i)==parent.frames[0].get_effective_mul(moni_out["port"]))) {
				// same reference & sync & same speed mode -> fuckin' A
				newval = 0;
	
      } else if ((parent.frames[0].status_port_sync[i]==3) &&
								 (parent.frames[0].status_port_freq[i]==parent.frames[0].status_port_freq[moni_out["port"]]) &&
								 (parent.frames[0].get_effective_mul(i)==parent.frames[0].get_effective_mul(moni_out["port"]))) {
				// similar frequency & same speed mode
				newval = 1;
	
      } else {
				newval = 2;
      }
    }
    
    if (sync_table[i] != newval) {
      sync_table[i] = newval;
      redraw_port(i);
    }
  }
}


function update_channel(port, ch, sig) {
	if (!sig_ctx)
		return;

  var mul = parent.frames[0].get_effective_mul(port)+1;
  if (mul==3) 
    mul=4;

  if ((parent.frames[0].status_port_mode[port]==56) && 
      (ch >= 56)) 
    return;

  if (ch%mul!=0)
    return;

  ch = ch/mul;

  var y = port*40;
  if (ch>=(32/mul))
    y += 20;
  var x = 20*(ch%(64/(mul*2)));
	
  if (sig>0) {		
    sig_ctx.fillStyle = get_sync_color(port);
    sig_ctx.fillRect(x*mul+1, y+1, 20*mul-1, 19);

  } else {
    sig_ctx.clearRect(x*mul+1, y+1, 20*mul-1, 19);
  }
}

function draw_dead_channel(port, ch, val) {
  var mul = parent.frames[0].get_effective_mul(port)+1;
  if (mul==3) 
    mul=4;

  if ((parent.frames[0].status_port_mode[port]==56) && 
      (ch >= 56)) 
    return;

  if (ch%mul!=0)
    return;

  ch = ch/mul;

  var y = port*40;
  if (ch>=(32/mul))
    y += 20;
  var x = 20*(ch%(64/(mul*2)));
	
  if (val>0) {		
    dead_ctx.clearRect(x*mul+1, y+1, 20*mul-1, 19);
    dead_ctx.fillRect(x*mul+1, y+1, 20*mul-1, 19);

  } else {
    dead_ctx.clearRect(x*mul+1, y+1, 20*mul-1, 19);
  }
}


function ess_dead_channels(buf) {
  last_dead = new Uint8Array(buf);
  dead_ctx.clearRect(0, 0, 640, 640);
  dead_ctx.fillStyle = color_dead;

  for (var i=0; i<128; i++) {
    var port = Math.floor(i/8);
    for (var j=0; j<8; j++) {
      draw_dead_channel(port, (i%8)*8+(7-j), last_dead[i]&(1<<j));
    }
  }
}


function redraw_port(port) {
  var bg = document.getElementById("bg_"+port);
  if (bg)
    bg.src = "/img/moni_bg_"+parent.frames[0].get_effective_mul(port)+"_"+sync_table[port]+".png";	

  if (last_signals) {
    for (var i=port*8; i<(port+1)*8; i++) {
      for (var j=0; j<8; j++) {
				update_channel(port, (i%8)*8+(7-j), last_signals[i]&(1<<j));
				if (last_dead)
					draw_dead_channel(port, (i%8)*8+(7-j), last_dead[i]&(1<<j));
      }
    }
  }

}


function draw_grid(port) {
  var mul = parent.frames[0].get_effective_mul(port)+1;
  if (mul==3) 
    mul=4;
	
  sig_ctx.fillStyle = color_grid;
  sig_ctx.fillRect(0, port*40, 640, 1);
  sig_ctx.fillRect(0, port*40+20, 640, 1);
  sig_ctx.fillRect(0, port*40+40, 640, 1);

  for (var x=0; x<=32/mul; x++)
    sig_ctx.fillRect(x*mul*20, port*40, 1, 41);

  if (parent.frames[0].status_port_mode[port]==56) {
    sig_ctx.fillStyle = color_56ch;
    sig_ctx.fillRect(481, port*40+20+1, 160, 19);
  }
}


function update_channel_info(port, ch) {
  var mul = parent.frames[0].get_effective_mul(port)+1;
  if (mul==3) 
    mul=4;

  if ((parent.frames[0].status_port_mode[port]==56) &&
      (ch*mul>=56)) {
    channel_info.style.display = 'none';
    return;
  }

  var y = port*40;
  if (ch>=(32/mul))
    y += 20;
  var x = 20*(ch%(64/(mul*2)))*mul;

  if (display_labels) {
    channel_info.innerHTML = "<span style='background: #"+parent.frames[0].labels_input_ports_bg[port]+"; color: #"+parent.frames[0].labels_input_ports_fg[port]+";'>"+parent.frames[0].labels_input_ports[port]+"</span> / <span style='background: #"+parent.frames[0].labels_audio_in_bg[port*64+ch]+"; color: #"+parent.frames[0].labels_audio_in_fg[port*64+ch]+";'>"+parent.frames[0].labels_audio_in[port*64+ch]+"</span>";

  } else {
    /*
      switch (sync_table[port]) {
      case 0:	channel_info.style.background = '#009900'; break;
      case 1: channel_info.style.background = '#cccc00'; break;
      case 2: channel_info.style.background = '#990000'; break;
      }
    */
    channel_info.innerHTML = "Port "+(port+1)+", Ch "+(ch+1);
  }

  channel_info.style.display = 'block';

  channel_info.style.top = (y+30)+'px';
  channel_info.style.left = x+'px';
}


function append_channel_info(str) {
	channel_info.innerHTML += "<br>"+str;
}


var pressed_1s=false, timeout_1s=null, timeout_blink=false, blink_state=0;


function update_selection() {
	sel_ctx.clearRect(0, 0, 640, 640);
  draw_selection(Math.floor(listen_channel/64), listen_channel%64, color_listen);
}


function select_blink() {
  if (!pressed_1s)
    return;

  //draw_selection(Math.floor(last_listen_channel/64), last_listen_channel%64, (blink_state==1)?color_listen:false);
  if (moni_settings["safe"] && (sync_table[last_port]!=0))
    draw_selection(last_port, last_ch, (blink_state==1)?color_blink_err:false);
  else
    draw_selection(last_port, last_ch, (blink_state==1)?color_blink:false);

  blink_state = 1-blink_state;
  timeout_blink = window.setTimeout("select_blink()", 100);
}
		

function mousedown_1s() {
  pressed_1s = true;
  blink_state = 0;
  timeout_blink = window.setTimeout("select_blink()", 100);
	set_routing(last_port*64+last_ch);
}


function set_routing(channel) {
	if (channel==-1)
		return;

	send_cmd("xp?"+channel+","+(moni_out["port"]*64+moni_out["channel"])+",0");
	if (moni_out["mode"]=="stereo") {
		// stereo routing
		send_cmd("xp?"+get_second_channel(channel)+","+(moni_out["port"]*64+moni_out["channel"]+1)+",0");
	}
}


function restore_routing() {
  pressed_1s = false;
  listen_channel = last_listen_channel;
  draw_selection(Math.floor(listen_channel/64), listen_channel%64, color_listen);
  set_routing(last_listen_channel);
  window.clearTimeout(timeout_blink);
}


function store_moni_out() {
  post_call('/wwwdata?monitor_out', JSON.stringify(moni_out));
}


function store_moni_settings() {
  post_call('/wwwdata?monitoring_tool', JSON.stringify(moni_settings));
}



//
// event callbacks
//


var last_port, last_ch, down_power, down_ch;


function canvas_mousemove(e) {
  var x, y;

  if (e.offsetX) {
    x = e.offsetX;
    y = e.offsetY;
  } else {
    x = e.layerX;
    y = e.layerY;
  }

  var port = Math.floor(y/40);
  if (port>15)
    return; 
  
  var mul = parent.frames[0].get_effective_mul(port)+1;
  if (mul==3) 	
    mul=4;
  
  if (x>639)
    return;
  
  var ch = Math.floor(x/20/mul);
  
  if (y%40>20)
    ch += 32/mul;
  
  if ((port != last_port) || (ch != last_ch)) {
		sel_canvas.style.cursor = 'pointer';

		update_selection();
  
    update_channel_info(port, ch);
    var allowed = parent.frames[0].permissions.xp_in[port*64+ch];

    if ((!moni_settings["safe"] || (moni_settings["safe"] && (sync_table[port]==0))) &&
				allowed) {
      draw_selection(port, ch, color_sel);
      
      if (pressed_1s) {
				set_routing(port*64+ch);

				if (moni_settings["safe"] && (sync_table[last_port]!=0))
					draw_selection(port, ch, (blink_state==1)?color_blink_err:false);
				else
					draw_selection(port, ch, (blink_state==1)?color_blink:false);
      }
    } else {
			sel_canvas.style.cursor = 'not-allowed';
			if (!allowed)
				append_channel_info("<span style='font-size: 10px; color: red;'>Input channel forbidden</span>");
			else 
				append_channel_info("<span style='font-size: 10px; color: red;'>Port asynchronous, safe mode enabled</span>");
		}

    last_port = port;
    last_ch = ch;
  }
}


function canvas_mousedown(e) {
  if (e.which!=1)
    return;

  if (moni_settings["safe"] && (sync_table[last_port]!=0))
    return;

	down_port = last_port;
	down_ch = last_ch;

  pressed_1s = false;
  timeout_1s = window.setTimeout("mousedown_1s()", 500);
}


function canvas_mouseup(e) {
  if (e.which!=1)
    return;
  if (pressed_1s) {
    restore_routing();
  } else {
    window.clearTimeout(timeout_1s);

		if ((down_port==last_port) && (down_ch==last_ch)) { // are we still over the same channel?
			draw_selection(Math.floor(listen_channel/64), listen_channel%64, false);
			last_listen_channel = listen_channel = last_port*64+last_ch;
			update_selection();
			set_routing(listen_channel);
		}
  }
}


function canvas_mouseout(e) {
  channel_info.style.display = 'none';
  draw_selection(last_port, last_ch, false);
  if ((last_port*64+last_ch)==listen_channel) {
    draw_selection(last_port, last_ch, color_listen);
  }
  last_port = -1;
  last_ch = -1;
  if (pressed_1s) {
    restore_routing();
  }
}


//
// eventsource callbacks
//


var last_signals = Array(128);


function signals(data) {
  if (!last_signals) {
    for (var i=0; i<128; i++) {
      last_signals[i] = (data[i]=='0')?'1':'0';
    }
  }

  for (var i=0; i<128; i++) {
    if (data[i]!=last_signals[i]) {
      var port = Math.floor(i/8);
      for (var j=0; j<8; j++) {
				var sig = data[i]&(1<<j);
				var lsig = last_signals[i]&(1<<j);
				if ((data[i]&(1<<j)) != (last_signals[i]&(1<<j))) {
					update_channel(port, (i%8)*8+(7-j), data[i]&(1<<j));
				}
      }
      last_signals[i] = data[i];
    }
  }
}

function ess_port_mode(port, mode) {
  sig_ctx.clearRect(480, port*40+20+1, 160, 19);
  draw_grid(port);
  redraw_port(port);
}


function ess_freq(port, freq) {
  update_sync_table();
}

function ess_sync(port, sync, t) {
  update_sync_table();
}

function ess_polysync(p) {
  update_sync_table();
}

function esc_poly_source(port, source) {
  update_sync_table();
}

function esc_xp(m, ch_in, ch_out) {
	if ((ch_out==(moni_out["port"]*64+moni_out["channel"])) ||
			((moni_out["mode"]=="stereo") &&
			 (ch_out==(moni_out["port"]*64+moni_out["channel"]+1)))) {

		if (ch_out==(moni_out["port"]*64+moni_out["channel"]))
			last_listen_channel = listen_channel = ch_in;

		update_monitoring_label();
		update_selection();
	}
}


function update_muls() {
  dead_ctx.clearRect(0, 0, 640, 640);
  sig_ctx.clearRect(0, 0, 640, 640);
  sel_ctx.clearRect(0, 0, 640, 640);
  
  for (var port=0; port<16; port++) {
    draw_grid(port);
    redraw_port(port);
  }
  update_moni_channelsel();
}

function esc_master_enable_fs(enable) {
	update_muls();
}

function esc_master_enable_clock(enable) {
	update_sync_table();
}

function esc_wck_mul(port, mul) {
  if (port<16) {
    dead_ctx.clearRect(0, port*40, 640, 40);
    sig_ctx.clearRect(0, port*40, 640, 40);
    sel_ctx.clearRect(0, port*40, 640, 40);
		
    draw_grid(port);
		
    redraw_port(port);
		
    if (port==moni_out["port"])
      update_moni_channelsel();

  } else if (parent.frames[0].config_master_enable_fs) {
    update_muls();
  }
  
  update_sync_table();
}


function esc_gain(ch, gain) {
	if (ch==moni_out["port"]*64+moni_out["channel"]) {
		if (!moni_out["mute"]) {
			update_gain();
			moni_out["gain"] = fader_gain_to_db(gain);
			store_moni_out();
		}
	}
}


//
// wwwdata callbacks
//


function cb_moni_out(data) {
    if (data.length>0) {
	try {
	    moni_out = JSON.parse(data);
	    
	    draw_selection(Math.floor(listen_channel/64), listen_channel%64, false);
	    last_listen_channel = listen_channel = parent.frames[0].config_xpa[moni_out["port"]*64+moni_out["channel"]];
	    draw_selection(Math.floor(listen_channel/64), listen_channel%64, color_listen);
	    document.getElementById('moni_mode_'+moni_out["mode"]).checked = true;
	    set_selectactive(document.getElementById('sel_moni_port'), moni_out["port"]);
	    
	    set_mute(moni_out["mute"]);
	    
	    update_moni_channelsel();
	    update_monitoring_label();
	    update_sync_table();
	    
	    update_gain();
	} catch (e) {
	}
    }
}


function cb_moni_settings(data) {
	if (data.length>0)
		moni_settings = JSON.parse(data);

	document.getElementById('mode_'+moni_settings["mode"]).checked = true;
  document.getElementById('dist_ch').value = moni_settings["distance"];
  //document.getElementById('cb_dim').checked = moni_settings["dim"];
  document.getElementById('cb_safemode').checked = moni_settings["safe"];

	update_selection();
	restore_routing();
}


function cb_display_dead_channels(data) {
  dead_channels = (data=='true');
  document.getElementById('cb_dead_channels').checked = dead_channels;
  dead_canvas.style.display = (dead_channels)?'block':'none';	
}


function cb_display_labels(data) {
  set_display_labels(data=='true');
}

function cb_keydown(e) {
  if (e.keyCode==68) { // 'd'
    set_display_labels(!display_labels);
  }
}


//
// site callbacks
//

function gain_changed(port, db) {
	var channels = moni_out["channel"];
	if (moni_out["mode"]=="stereo")
		channels += ","+(moni_out["channel"]+1);
		
  send_cmd("set_gain?"+db+","+channels);
}


function gain_mousedown(e) {
	if (moni_out["mute"])
		return;

	if (e.which==1) {
    if (e.ctrlKey) {
      gain_changed(0, 0);
      fader_set_gain(document.getElementById('fader'), 53);
    } else {
      var cs = document.getElementById('fader');
      if (cs && (cs.style.display=='block')) {
				cs.style.display = 'none';
      } else {
				var g = document.getElementById('gain');
				fader_mono_popup(document.getElementById('gain_container'), 'fader', 0, fader_gain_to_db(parent.frames[0].config_gains[moni_out["port"]*64+moni_out["channel"]]), 0, 0, "Mon", gain_changed);
      }
    }
		
  } else if (e.which==2) {
    gain_changed(0, 0);
    fader_set_gain(document.getElementById('fader'), 53);
  }
}


/**
 * Monitor configuration: Mono/Stereo
 **/
function set_moni_mode(new_mode) {
  moni_out["mode"] = new_mode;
	gain_changed(0, moni_out["gain"]);
	if ((new_mode=="mono") && (moni_settings["mode"]=="dual")) {
		document.getElementById("mode_single").checked = true;
		set_mode("single");
	}
	document.getElementById("mode_dual").disabled = (new_mode=="mono");

	restore_routing();
  update_moni_channelsel(); 
	update_monitoring_label();
  store_moni_out();
}


function toggle_mute() {
	moni_out["mute"] = !moni_out["mute"];
	set_mute(moni_out["mute"]);
	store_moni_out();
}

function set_mute(enabled) {
	var g = document.getElementById("gain_container");
	var m = document.getElementById("moni_mute");

	if (enabled) {
		g.style.opacity = 0.5;
		g.title = "Muted";
		gain_changed(0, -120);
		var cs = document.getElementById('fader');
		if (cs && (cs.style.display=='block'))
			cs.style.display = 'none';

		m.style.backgroundColor = 'red';

	}	else {
		g.style.opacity = 1;
		g.title = "";
		gain_changed(0, moni_out["gain"]);
		
		m.style.backgroundColor = '#999';
	}
}


/**
 * Monitoring options: Single/Dual channel mode
 **/
function set_mode(new_mode) {
	moni_settings["mode"] = new_mode;
	update_selection();
	restore_routing();
	store_moni_settings();
	document.getElementById('dist_ch').disabled = (new_mode=="single");
}


function set_ch_distance(new_dist) {
	moni_settings["distance"] = parseInt(new_dist, 10);
	update_selection();
	restore_routing();
  store_moni_settings();
}


function set_dim_mode(new_mode) {
	moni_settings["dim"] = new_mode;
  store_moni_settings();
}


function set_safe_mode(new_safe_mode) {
  moni_settings["safe"] = new_safe_mode;
  store_moni_settings();
}


function update_moni_channelsel() {
  var sel = document.getElementById('sel_moni_channel');
  sel.options.length = 0;
  var max = 64;
  if (parent.frames[0].get_effective_mul(moni_out["port"])==1)
    max = 32;
  else if (parent.frames[0].get_effective_mul(moni_out["port"])==2)
    max = 16;

	var moni_inc = (moni_out["mode"]=="mono")?1:2;

  for (var i=0; i<max; i+=moni_inc) {
    var opt = document.createElement('option');
    if (moni_inc==1) {
			if (parent.frames[0].permissions.xp_out[moni_out["port"]*64+i]==0)
				continue;
      opt.text = "Channel "+(i+1);

    } else if (moni_inc==2) {
			if ((parent.frames[0].permissions.xp_out[moni_out["port"]*64+i]==0) ||
					(parent.frames[0].permissions.xp_out[moni_out["port"]*64+i+1]==0))
				continue;
      opt.text = "Channels "+(i+1)+"+"+(i+2);
		}
    opt.value = i;
    sel.options.add(opt);
  }

  if ((moni_inc==2) && ((moni_out["channel"]%2)==1))
    moni_out["channel"]--;
  set_selectactive(sel, moni_out["channel"]);
}


function set_moni_port(port) {
  moni_out["port"] = port;
  set_routing(listen_channel);
  update_moni_channelsel();
  update_sync_table();
  store_moni_out();
}


function set_moni_channel(ch) {
  moni_out["channel"] = parseInt(ch, 10);
  set_routing(listen_channel);
	moni_out["gain"] = fader_gain_to_db(parent.frames[0].config_gains[moni_out["port"]*64+moni_out["channel"]]);
  store_moni_out();
	update_gain();
}


function set_dead_channels(val) {
  dead_channels = val;
  dead_canvas.style.display = (val)?'block':'none';
  post_call('/wwwdata?dead_channels', val, false);
}


function set_display_labels(val) {
  display_labels = val;
  document.getElementById('cb_show_labels').checked = display_labels;
  if (channel_info.style.display=='block')
    update_channel_info(last_port, last_ch);
	update_monitoring_label();
  post_call('/wwwdata?display_labels', val, false);
}



//


function ch_not_permitted(ch) {
  var port = Math.floor(ch/64);
  ch = ch%64;

  var mul = parent.frames[0].get_effective_mul(port)+1;
  if (mul==3) 
    mul=4;

  if ((parent.frames[0].status_port_mode[port]==56) && 
      (ch >= 56)) 
    return;

  if (ch%mul!=0)
    return;

  ch = ch/mul;

  var y = port*40;
  if (ch>=(32/mul))
    y += 20;
  var x = 20*(ch%(64/(mul*2)));
	
  perm_ctx.fillRect(x*mul+1, y+1, 20*mul-1, 19);
}


function update_monitoring_label() {
	var o = document.getElementById("monitoring");
	if (listen_channel==-1) {
		o.innerHTML = "-";
		
	} else {
		if (moni_out["mode"]=="mono") {
			// single channel monitoring
			var port = Math.floor(parent.frames[0].config_xpa[moni_out["port"]*64+moni_out["channel"]]/64);
			var ch = parent.frames[0].config_xpa[moni_out["port"]*64+moni_out["channel"]]%64;
			
			if (display_labels) {
				o.innerHTML = "<span style='background: #"+parent.frames[0].labels_input_ports_bg[port]+"; color: #"+parent.frames[0].labels_input_ports_fg[port]+";'>"+parent.frames[0].labels_input_ports[port]+"</span> / <span style='background: #"+parent.frames[0].labels_audio_in_bg[port*64+ch]+"; color: #"+parent.frames[0].labels_audio_in_fg[port*64+ch]+";'>"+parent.frames[0].labels_audio_in[port*64+ch]+"</span>";
			} else {
					o.innerHTML = "Port "+(port+1)+", Ch "+(ch+1);
				}
			} else {
				// dual ch. monitoring
				
				var port1 = Math.floor(parent.frames[0].config_xpa[moni_out["port"]*64+moni_out["channel"]]/64);
				var ch1 = parent.frames[0].config_xpa[moni_out["port"]*64+moni_out["channel"]]%64;
				var port2 = Math.floor(parent.frames[0].config_xpa[moni_out["port"]*64+moni_out["channel"]+1]/64);
				var ch2 = parent.frames[0].config_xpa[moni_out["port"]*64+moni_out["channel"]+1]%64;
				
				if (display_labels) {
					o.innerHTML = "<span style='background: #"+parent.frames[0].labels_input_ports_bg[port1]+"; color: #"+parent.frames[0].labels_input_ports_fg[port1]+";'>"+parent.frames[0].labels_input_ports[port1]+"</span> / <span style='background: #"+parent.frames[0].labels_audio_in_bg[port1*64+ch1]+"; color: #"+parent.frames[0].labels_audio_in_fg[port1*64+ch1]+";'>"+parent.frames[0].labels_audio_in[port1*64+ch1]+"</span><br><span style='background: #"+parent.frames[0].labels_input_ports_bg[port2]+"; color: #"+parent.frames[0].labels_input_ports_fg[port2]+";'>"+parent.frames[0].labels_input_ports[port2]+"</span> / <span style='background: #"+parent.frames[0].labels_audio_in_bg[port2*64+ch2]+"; color: #"+parent.frames[0].labels_audio_in_fg[port2*64+ch2]+";'>"+parent.frames[0].labels_audio_in[port2*64+ch2]+"</span>";
				} else {
					o.innerHTML = "Port "+(port1+1)+" / Ch "+(ch1+1)+"<br>"+"Port "+(port2+1)+" / Ch "+(ch2+1);
				}
			}
		}
}


function permissions_updated() {
  perm_ctx.clearRect(0, 0, 640, 640);
  perm_ctx.fillStyle = color_disabled;
  var port_possible = 0;
  var pport = 0;
  
  var sel = document.getElementById('sel_moni_port');
  sel.options.length = 0;

  for (var i=0; i<1024; i++) {
    if (parent.frames[0].permissions.xp_in[i]==0)
      ch_not_permitted(i);
    
		if (parent.frames[0].permissions.xp_out[i])
      port_possible = 1;
    
    if (i%64==63) {
      if (port_possible) {
				var opt = document.createElement('option');
				opt.text = 'Port '+(pport+1);
				opt.value = pport;
				sel.options.add(opt);
      }
      pport++;
      port_possible = 0;
    }
  }
  ajax_call('/wwwdata?monitor_out', cb_moni_out);
}


function update_gain() {
	var db = 0;

	if (moni_out["mute"])
		db = moni_out["gain"];
	else
		db = fader_gain_to_db(parent.frames[0].config_gains[moni_out["port"]*64+moni_out["channel"]]);

	var fader = document.getElementById('fader');
	if (fader && !fader_drag_active(fader)) {
		fader_set_knob(fader, db);
	}

  var g = document.getElementById('gain');
	if (db<0) {
		g.style.backgroundColor = 'green';
		g.style.color = 'white';
	} else if (db>0) {
		g.style.backgroundColor = 'yellow';
		g.style.color = 'red';
	} else { 
		g.style.backgroundColor = '#999999';
		g.style.color = 'black';
	}
	
	if (db<-67) {
		g.innerHTML = '&#8734;';
	} else if (Math.abs(db)>10) {
		g.innerHTML = Math.round(Math.abs(db));
	} else {
		var dbval = Math.round(Math.abs(db*10));
		g.innerHTML = dbval/10;
	}	
}

//
//
//


function monitoring_init() {
  update_sync_table();

  rt_connect();

  var o;
  var labels = document.getElementById("moni_labels");
  var bg = document.getElementById("moni_bg");
  dead_canvas = document.getElementById('dead_canvas');
  dead_ctx = dead_canvas.getContext('2d');
  sig_canvas = document.getElementById('sig_canvas');
  sig_ctx = sig_canvas.getContext('2d');
  sel_canvas = document.getElementById('sel_canvas');
  sel_ctx = sel_canvas.getContext('2d');
  perm_canvas = document.getElementById('perm_canvas');
  perm_ctx = perm_canvas.getContext('2d');

  channel_info = document.getElementById("channel_info");

  sel_canvas.onmousemove = canvas_mousemove;
  sel_canvas.onmousedown = canvas_mousedown;
  sel_canvas.onmouseup = canvas_mouseup;
  sel_canvas.onmouseout = canvas_mouseout;

  ajax_call('/wwwdata?monitor_out', cb_moni_out);
  ajax_call('/wwwdata?monitoring_tool', cb_moni_settings);
  ajax_call('/wwwdata?dead_channels', cb_display_dead_channels);
  ajax_call('/wwwdata?display_labels', cb_display_labels);

  for (var i=0; i<16; i++) {
    sync_table[i] = 0;

    var o = document.createElement("img");
    o.id = "bg_"+i;
    o.style.top = (i*40)+"px";
    bg.appendChild(o);
    esc_wck_mul(i, parent.frames[0].get_effective_mul(i));
    ess_port_mode(i, parent.frames[0].status_port_mode[i]);

    o = document.createElement("div");
    o.id = "label_"+i;
    o.innerHTML = "Port "+(i+1);
    o.style.top = (i*40)+"px";
    labels.appendChild(o);
  }

	document.getElementById('gain').onmousedown = gain_mousedown;

  ess_dead_channels(parent.frames[0].status_dead_channels);

  permissions_updated();

  window.onkeydown = cb_keydown;
}
