
function show_log(id) {
    window.open('/data/system_script_log?'+id, 'scriptlog', 'location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no,height=600,width=700');
}


function btn_color(o, id) {
    if (scripting_system_tally[id]) {
	o.style.backgroundColor = system_script_meta[id]["fg"];
	o.style.color = system_script_meta[id]["bg"];				
    } else {
	o.style.backgroundColor = system_script_meta[id]["bg"];
	o.style.color = system_script_meta[id]["fg"];
    }
}

var system_script_meta = false;

function update_system_scripts(response) {
    system_script_meta = JSON.parse(response);

    // remove all buttons
    var container = document.getElementById('system_scripts');
    while (container.hasChildNodes())
	container.removeChild(container.firstChild);

    var max_y = 0;
    
    for (var id=0; id<64; id++) {
        if (system_script_meta[id]) {
	    var y = 35+Math.floor(id/4)*70;
	    if (y>max_y)
		max_y = y;
	    
	    var x = 20+id%4*180;
	    
  	    var o = document.createElement("div");
	    o.id = "script_"+id;							
	    o.className = 'scriptbutton';

	    o.style.position = 'absolute';
	    o.style.left = x+"px";
	    o.style.top = y+"px";
	    o.scriptid = id;
	    o.onclick = run_script;
	    btn_color(o, id);
	    o.style.cursor = "pointer";
	    o.title = system_script_meta[id]["desc"];
	    o.innerHTML = "<div id='s_log_"+id+"' style='display: none;' class='scriptlog' onclick='event.stopPropagation(); show_log("+id+");'>View log..</div><div class='script_title' id='script_title_"+id+"'>"+system_script_meta[id]["name"]+"</div>";
	    
	    container.appendChild(o);

	    ajax_call("/data/system_script_haslog?"+id, cb_logfile);
	}
    }

    container.style.height = (max_y+50)+"px";
}


function cb_logfile(res) {
    var data = res.split(',');
    var o = document.getElementById("s_log_"+data[0]);
    if (o)
	o.style.display = (data[1]=='y')?"block":"none";
}


function run_script(e) {
    var srcElement;
    
    if (e.srcElement) {
	srcElement = e.srcElement;
    } else if (e.originalTarget) {
	srcElement = e.originalTarget;
    }		

    if (typeof(srcElement.scriptid)=="undefined")
	srcElement = srcElement.parentElement;;
    
    ajax_call('/data/run_system_script?'+srcElement.scriptid);		
}

var glows = [];

function btn_unglow() {
    var id = glows.shift();
    var o = document.getElementById("script_"+id);
    if (o) {
	o.style.border = o.oldborder;
	o.oldborder = null;
    }
}

function btn_glow(id, color) {
    var o = document.getElementById("script_"+id);
    if (o) {
	if (!o.oldborder)
	    o.oldborder = o.style.border;
	o.style.border = "2px solid "+color;
	glows.push(id);
	setTimeout(btn_unglow, 2000);
    }
}

function system_scripts_updated() {
    ajax_call('/data/system_scripts', update_system_scripts);
}

function system_script_success(id) {
    ajax_call("/data/system_script_haslog?"+id, cb_logfile);
    btn_glow(id, "#448844");
}

function system_script_error(id) {
    ajax_call("/data/system_script_haslog?"+id, cb_logfile);
    btn_glow(id, "#884444");
}

scripting_system_tally = Array(64);

function system_script_tally(scriptid, status) {
    scripting_system_tally[scriptid] = status;
    btn_color(document.getElementById('script_'+scriptid), scriptid);
}


function events_connect() {
  document.getElementById('connecting').style.display = 'none';
}

function events_disconnect() {
  document.getElementById('connecting').style.display = 'block';
}


function scripts_init() {
    if (!("WebSocket" in window)) {
	window.location = '/en/browser.html';
	return;
    }
    
    ajax_call('/data/system_scripts', update_system_scripts);
    ajax_call('/data/system_scripts', update_system_scripts);					
    ws_init(events_connect, events_disconnect);
}

window.onload=scripts_init;
