/**
 * @copyright D.O.TEC
 * @author Florian Faber, florian.faber@directout.eu
 * @version 2 (05.05.2013)
 **/

var bg_act = '009000';
var bg_forbidden = '900000';
var labels;
var input_active = false;


function cb_keydown(e) {
  if (input_active)
    return;
  
  if (e.keyCode==68) { // 'd'
    push_cycle_button(document.getElementById("show_labels"));
    e.preventDefault();

  } else if (e.which==82) { // 'r'
    restore();

  } else if (e.which==83) { // 's'
    snapshot();
  }
}


//
// callback functions for status.js
//

	
function esc_serxp(p_in, p_out) {
  mini_xp(p_out, p_in);
}


function esc_serbaud(p, baud) {
  set_selectactive(document.getElementById("b"+(p+16)), baud);
}


function esc_rs4xx_mode(val) {
  if (val==0)
    document.getElementById('rs4xx_mode_422').checked = true;
  else 
    document.getElementById('rs4xx_mode_485').checked = true;
}


function esc_rs485_echo(val) {
  document.getElementById('rs485_echo').checked = (val==1);
}


function esl(type, id, label, fg, bg) {
  if (!labels)
    return;

  if (type==130) { // input port
    mini_update_in(id);

  } else if (type==131) { // output port
    mini_update_out(id);

  }
}


//
// callback functions for minimatrix.js
//


function mini_cb_input(active) {
  input_active = active;
}


function mini_cb_color(dst, src) {
  if (mini_cb_enabled('src', src) && mini_cb_enabled('dst', dst))
    return bg_act;

  return bg_forbidden;
}


function mini_cb_cursor(dst, src) {
  if (mini_cb_enabled('src', src) && mini_cb_enabled('dst', dst))
    return "pointer";

  return "not-allowed";
}


function mini_cb_click(dst, src) {
  send_cmd("serxp?"+dst+","+src);
}

var names_hw = ["Port 1", "Port 2", "Port 3", "Port 4",
		"Port 5", "Port 6", "Port 7", "Port 8",
		"Port 9", "Port 10", "Port 11", "Port 12",
		"Port 13", "Port 14", "Port 15", "Port 16",
		"RS232", "RS4XX", "USB", "Controller"];

function mini_cb_label(type, id) {
  if (id==-1) {
    return "N/C";
  } else if (id>=16) {
    if (type=="src") {
			var str = "<select onchange=\"send_cmd('serbaud?"+(id-16)+",'+get_selectactive(this));\" style='width: 100%;' id='b"+(id)+"'><option value='0'";
			if (parent.frames[0].config_serbaud[id-16]==0) str += " selected";
			str += ">"+names_hw[id]+" 9.6k</option><option value='1'";
			if (parent.frames[0].config_serbaud[id-16]==1) str += " selected";
			str += ">"+names_hw[id]+" 19.2k</option><option value='2'";
			if (parent.frames[0].config_serbaud[id-16]==2) str += " selected";
			str += ">"+names_hw[id]+" 38.4k</option><option value='3'";
			if (parent.frames[0].config_serbaud[id-16]==3) str += " selected";
			str += ">"+names_hw[id]+" 115.2k</option></select>";
			return str;
		} else
      return names_hw[id];
  } else {
    if (labels==1) {
      if (type=='src')
	return parent.frames[0].labels_serial_in[id];
      else
	return parent.frames[0].labels_serial_out[id];
    } else if (labels==2) {
      if (type=='src')
	return parent.frames[0].labels_input_ports[id];
      else
	return parent.frames[0].labels_output_ports[id];
    } else {
      return names_hw[id];
    }
  }
}


function mini_cb_enabled(type, id) {
  if (type=='src') {
    if (id==-1)
      return true;
    return (parent.frames[0].permissions.serial_input[id]==1);
  } else {
    return (parent.frames[0].permissions.serial_output[id]==1);
  }
}


function mini_cb_bg(type, id) {
  if (labels==1) {
    if (type=='src') 
      return parent.frames[0].labels_serial_in_bg[id];
    else
      return parent.frames[0].labels_serial_out_bg[id];
  } else if (labels==2) {
    if (type=='src')
      return parent.frames[0].labels_input_ports_bg[id];
    else
      return parent.frames[0].labels_output_ports_bg[id];
  } else {
    return '';
  }
}


function mini_cb_fg(type, id) {
  if (labels==1) {
    if (type=='src') 
      return parent.frames[0].labels_serial_in_fg[id];
    else
      return parent.frames[0].labels_serial_out_fg[id];
  } else if (labels==2) {
    if (type=='src')
      return parent.frames[0].labels_input_ports_fg[id];
    else
      return parent.frames[0].labels_output_ports_fg[id];
  } else {
    return '';
  }
}


function mini_cb_label_editable(type, id) {
  return (labels==1);
}


function mini_cb_label_changed(type, id, newlabel, fg, bg) {
  post_cmd("label?"+((type=='src')?130:131)+","+id+","+fg+","+bg, newlabel);
}



var last_activity = Array(20);

function signals(data) {
		if (data.length<134)
				return;
		
		for (var i=0; i<20; i++) {
				var bytepos = Math.floor(i/8);
				var bitpos = i%8;
				var sig = ((data[bytepos+131]&(1<<bitpos))>0)?1:0;
				if (sig!=last_activity[i]) {
						update_activity(i, sig);
						last_activity[i] = sig;
				}
		}		
}


//
// internal
//


function update_activity(port, val) {
		var o = document.getElementById("act_"+port);
		if (o) {
				o.src = (val)?'/img/act_on.png':'/img/act_off.png';
		}
}

function set_rs4xx_mode() {
  send_cmd('rs4xx_mode?'+((document.getElementById('rs4xx_mode_422').checked)?0:1));
}


function show_labels(v) {
  if (typeof(v)=='string') {
    v = parseInt(v, 10);
    if ((typeof(v)!='number') || isNaN(v))
      v = 0;
    set_cycle_button(document.getElementById("show_labels"), v);
  } else if (labels != v) {
    post_call('/wwwdata?serialmatrix_labels', v, false);
  }

  labels = v;

  for (i=0; i<16; i++) {
    mini_update_in(i);
    mini_update_out(i);
  }
}


function set_11() {
  for (i=0; i<20; i++)
    send_cmd("serxp?"+i+","+i);
}

function set_nc() {
  for (i=0; i<20; i++) 
    send_cmd("serxp?"+i+",-1");
}


function permissions_updated() {
  mini_update_all();
	for (var i=0; i<20; i++)
		esc_serxp(parent.frames[0].config_ser[i], i);
}


function serialmatrix_init() {
    if (parent.frames[0].status_board>1) {
	document.getElementById("activity").style.display = "block";
	rt_connect();
    }
    
    ajax_call('/wwwdata?serialmatrix_labels', show_labels);
    
    init_minimatrix(20);
    
    for (i=0; i<20; i++) 
	esc_serxp(parent.frames[0].config_ser[i], i);
    
    //for (i=0; i<4; i++)
    //  set_selectactive(document.getElementById("b"+(i+16)), parent.frames[0].config_serbaud[i]);
    
    esc_rs4xx_mode(parent.frames[0].config_rs4xx_mode);
    esc_rs485_echo(parent.frames[0].config_rs485_echo);
    
    init_cycle_button(document.getElementById("show_labels"), ['System Labels', 'User Labels'], show_labels);
    
    window.onkeydown = cb_keydown;
    
    permissions_updated();
}

window.onload = serialmatrix_init;
