/**
 * M1k2 status update
 * @copyright Florian Faber, florian.faber@directout.eu
 * @version 5 (18.09.2017)
 *          - window position storage
 * @version 4 (25.11.2016)
 *          - added smart SFP support
 * @version 3 (03.05.2013)
 *          - added permission handling
 * @version 2 (31.08.2011) 
 *          - new graphical layout
 * @version 1 (12.11.2010) 
 **/

var connected = 0;

menu_categories = [[1, "Routing", "system"],
		   [2, "Configuration", "system"],
		   [3, "Tools", "system"],
		   [4, "Misc", "system"],
		   [5, "My Account", "user"]];
menu_items = [[
    //[3, "Group view", "/en/routing/group.html", , "system"],
    [5, "Port Matrix", "/en/routing/portmatrix.html", , "system"],
    [4, "Channel Matrix..", "/matrix.html", "_blank", "system"],
    [1, "MIDI Matrix", "/en/routing/midixp.html", , "system"],
    [2, "Serial Matrix", "/en/routing/serxp.html", , "system"]
],
	      [[2, "Ports", "/en/config/port.html", , "system"],
	       [3, "WCK", "/en/config/wck.html", , "system"],
	       [1, "Device", "/en/config/device.html", , "system"],
	       [4, "User", "/en/config/user.html", , "system"],
	       [5, "Backup/Restore", "/en/config/backup.html", , "system"]
	      ],
	      [[1, "Monitoring", "/en/tools/monitoring.html", , "system"],
	       [2, "Gain map", "/en/tools/gains.html", , "system"],
	       [3, "MIDI", "/en/tools/midi.html", , "system"],
	       [4, "System Scripts", "/en/system_scripts.html", , "system"]
	      ],
	      //[4, "Andiamo", "/en/tools/mc.html", , "system"]],
	      [[3, "Version", "/en/misc/status.html", , "system"],
	       [1, "Live-Log", "/livelog.html", "_blank" , "system"],
	       [2, "Support", "/en/misc/support.html", , "system"],
	       [5, "Licenses", "/en/misc/licenses.html", , "system"]
	      ],
	      [[1, "Files", "/en/myfiles.html", , "user"],
	       [2, "Account", "/en/myaccount.html", , "user"],
	       [3, "Permissions", "/en/mypermissions.html", , "user"],
	       //[5, "My Scripts", "/en/myscripts.html", , "user"],
	      ]
	     ];

last_item = [0, 0, 0, 0, 0];
last_port = 0;

sync_states = ["No signal", "Lock", "??", "Sync"];
wck_sources = ["Port 1", "Port 2", "Port 3", "Port 4",
	       "Port 5", "Port 6", "Port 7", "Port 8",
	       "Port 9", "Port 10", "Port 11", "Port 12",
	       "Port 13", "Port 14", "Port 15", "Port 16",
	       "WCK Input", "Video 44.1kHz", "Video 48kHz", "Internal 44.1kHz",
	       "Internal 48kHz"];
fs_strings = ["1FS", "2FS", "4FS"];

status_port_freq = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
status_port_sync = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
status_port_mode = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
status_port_frame = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
status_port_t = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
status_video_mode = 0;
status_temp = 0;
status_fan = 0;
status_psu = [ 0, 0 ];
status_key = 0;
status_board = 0;
status_controller = 0;
status_serial = 0;
status_io_ports = [ [0, 0, 0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0, 0, 0]];
status_io_present = [0, 0];
status_io_power = [0, 0];
status_io_serial = [0, 0];
status_io_firmware = [0, 0];
status_firmware = [ 0, 0, 0 ];
status_dead_channels = "";
status_hwaddr = "";
status_polysync = 0;
status_usage = [0, 0];
status_doppelgaenger = 0;
status_master_source = 0;
status_wck_mode = 0;
status_snapshot = [];
status_snapshot_changed = 0;
status_local_control = 0;

config_poly_source = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
config_wck_mul = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
config_wck_pll = -1;
config_master_enable_clock = 0;
config_master_enable_fs = 0;
config_master_fallback = [ 0, 0 ];
config_port_mode = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
config_port_frame = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
config_port_input_redundancy = Array(16);
config_port_output_redundancy = Array(16);
config_port_follow = [ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 ];
config_gpo = [ 0, 0, 0, 0 ];
config_gpo_automation = [ 0, 0, 0, 0 ];
config_gpo_polarity = [ 0, 0, 0, 0 ];
config_term = 0;
config_xpo = Array(1024);
config_xpa = Array(1024);
config_lock = Array(1024);
config_gain_lock = Array(1024);
config_gains = Array(1024);
config_midi = Array(18);
config_ser = Array(20);
config_serbaud = Array(4);
config_temps = [0, 0, 0];
config_blink_unsaved = 0;
config_state_idle = 0;
config_identify = 0;
config_mirror = 0;
config_master_ip = 0;
config_mirror_data = 0;
config_msg_level = 0;
config_rs4xx_mode = 0;
config_rs485_echo = 0;
config_slot_power = Array(2);
config_portgains = Array(16);
config_portgain_modes = Array(16);
config_96k_follow = 0;
config_labels_inherit = 0;
config_silent_mode = 0;
config_ip_reset = 0;
config_password_reset = 0;
config_auto_57ch = 0;
config_subcode = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]; 

plugin_perms = Array();
plugin_active = Array();

settings_profile = 0;
settings_network = 0;
settings_name = "";
settings_contact = "";

labels_audio_in = Array(1024);
labels_audio_in_bg = Array(1024);
labels_audio_in_fg = Array(1024);
labels_audio_out = Array(1024);
labels_audio_out_bg = Array(1024);
labels_audio_out_fg = Array(1024);
labels_serial_in = Array(20);
labels_serial_in_bg = Array(20);
labels_serial_in_fg = Array(20);
labels_serial_out = Array(20);
labels_serial_out_bg = Array(20);
labels_serial_out_fg = Array(20);
labels_midi_in = Array(18);
labels_midi_in_bg = Array(20);
labels_midi_in_fg = Array(20);
labels_midi_out = Array(18);
labels_midi_out_bg = Array(20);
labels_midi_out_fg = Array(20);
labels_input_ports = Array(18);
labels_input_ports_bg = Array(20);
labels_input_ports_fg = Array(20);
labels_output_ports = Array(18);
labels_output_ports_bg = Array(20);
labels_output_ports_fg = Array(20);

gain_sel = Array(1024);
portgain_sel = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];

scripting_system_tally = Array(64);

iomask_ports = false;
//iomask_xps = new Array(16).fill(new Array(16));


myname = "";
myperms = Array();
helpurl = "index.html";
pagetitle = "";

data_initialized = false;
permissions = false;

history_scale = 0

redundancy_active = 0;

slaves = Array();

oldmodules = false;
oldlevels = false;
sfp_msgs = Array(16);

//
// window positioning
//


windows = [{id:"matrix",
	    url:"/matrix.html",
	    left:100,
	    top:100,
	    width:800,
	    height:600,
	    extra:"",
	    window:null,
	    status:"closed"},
	   {id:"help",
	    url:"/en/help/index.html",
	    left:100,
	    top:100,
	    width:800,
	    height:600,
	    extra:"",
	    window:null,
	    status:"closed"},
	   {id:"scriptpanel",
	    url:"/scriptpanel.html",
	    left:100,
	    top:100,
	    width:800,
	    height:600,
	    extra:",status=no,titlebar=no,toolbar=no",
	    window:null,
	    status:"closed"}
	  ];

function window_stringify_filter(key, value) {
    if (key=="window")
	return null;
    return value;
}


function window_scan() {
    if (myname=="")
	return;
    
    for (let w of windows) {
	if (w.window!=null) {
	    if (w.window.closed) {
		w.status="closed";
		w.window = null;
		window_store();
	    } else if ((w.window.screenX != w.left) || (w.window.screenY != w.top) ||
		       (w.window.innerWidth != w.width) || (w.window.innerHeight != w.height)) {
		w.left = w.window.screenX;
		w.top = w.window.screenY;
		w.width = w.window.innerWidth;
		w.height = w.window.innerHeight;
		w.title = w.window.title;
		window_store();
	    }
	}
    }
}

/**
 * Store the state of all popup-windows as JSON data in wwwdata.
 **/
function window_store() {
    post_call('/wwwdata?windows', JSON.stringify(windows, window_stringify_filter), false);
}


function window_open(id, uri) {
    for (var w of windows) {
	if (w.id==id) {
	    if (w.window==null) {
		w.window = window.open(uri, id, "left="+w.left+",top="+w.top+",width="+w.width+",height="+w.height+""+w.extra, true);
		if ((w.status!="open") || (w.url!=uri)) {
		    w.status = "open";
		    w.title = w.window.title;
		    window_store();
		}
	    } else {
		w.window.location = uri;
		if (w.url != uri) {
		    window_store();
		}
	    }
	}
    }
}


function window_callback(res) {
    if (res=="")
	return;
    
    var ws = JSON.parse(res);
    if (ws) {
	windows = ws;
	for (var w of windows) {
	    w.window = null;
	    if (w.status=="open") {
		//parent.frames[1].location = '/en/session_restore.html';
		parent.frames[1].location = '/en/routing/portmatrix.html';
		return;
	    }
	}
    }
    parent.frames[1].location = '/en/routing/portmatrix.html';
}


function window_close_all() {
    for (var w of windows) {
	if ((w.status=="open") && (w.window!=null)) {
	    w.window.close();
	}
    }
}


//
// permissions
//


function update_permission(str) {
    permissions = JSON.parse(str);
    if (parent.frames[1].permissions_updated)
	parent.frames[1].permissions_updated();
}

function permissions_updated(permid) {
    if (permid==permissions.permid)
	ajax_call('/data/permission', update_permission);
}

function update_myname(name) {
    permissions = false;
    
    if (config_mirror>0) {
	document.getElementById('user').innerHTML = 'Slave to <a href="http://'+config_master_ip+'/index.html" target="_blank">'+config_master_ip+'</a>';
	parent.frames[1].location = '/en/slave.html';
	
    } else {
	if ((myname!="") && (name=="")) {
	    // logout/server shutdown
	    window_close_all();
	    if (parent.frames[1].location.pathname != '/en/login.html') 
		parent.frames[1].location = '/en/login.html';
	}
	
	myname = name;
	
	var o = document.getElementById('user');
	if (myname != '') {
	    o.innerHTML = name;
	    ajax_call('/data/permission', update_permission);
	    ajax_call('/data/myperms', update_myperms);
	    if (parent.frames[1].location.pathname == '/en/login.html') { 
		parent.frames[1].location = '/en/routing/portmatrix.html';
	    }
	    ajax_call("/wwwdata?windows", window_callback);
	} else {
	    o.innerHTML = '';
	    if (parent.frames[1].location.pathname != '/en/login.html') 
		parent.frames[1].location = '/en/login.html';
	}
    }
}


function update_myperms(str) {
    myperms = JSON.parse(str);
    if (parent.frames[1].init_mypermissions) 
	parent.frames[1].init_mypermissions();
}

function opt_perms_changed(userid, upper, lower) {
    ajax_call('/data/myname', update_myname);
    ajax_call('/data/myperms', update_myperms);
}



function create_menu(category, item) {
    if (myname=='')
	ajax_call('/data/myname', update_myname);
    
    str = "<div id='menubox'><div id='menu'><ul>";
    for (c=0; c<menu_categories.length; c++) {
	str += "<li><a href='"+menu_items[c][last_item[c]][2]+"' class='";
	if (category==menu_categories[c][0])
	    str += "selected ";
	str += menu_categories[c][2]+"'>"+menu_categories[c][1]+"</a>";
	if (category==menu_categories[c][0]) {
	    str += "<ul id='submenu'>";
	    for (i=0; i<menu_items[c].length; i++) {
		str += "<li><a href='"+menu_items[c][i][2]+"' class='";
		if (item==menu_items[c][i][0]) {
		    str += "selected ";
		    last_item[c] = i;
		}
		str += menu_items[c][i][4]+"'";
		if (menu_items[c][i][3])
		    str += " target='"+menu_items[c][i][3]+"'";
		str += ">"+menu_items[c][i][1]+"</a></li>";
	    }
	    str += "</ul>";
	}
	str += "</li>";
    }
    str += "</ul></div><img id='menu_fixed' width='20' height='20' alt='Sticky menu' onclick='fix_menu(this.fixed);'></div>";
    
    ajax_call('/wwwdata?menu_fixed', parent.frames[1].init_menu);
    return str;
}


function get_effective_source(port) {
    if (config_master_enable_clock) {
	return status_master_source;
    }
    
    if (port<16)
	port = config_port_output_redundancy[port];
    
    port = config_port_follow[port];
    

    return config_poly_source[port];
}


function get_effective_mul(port) {
    if (config_master_enable_fs)
	return config_wck_mul[17];
    
    if (port<16)
	port = config_port_output_redundancy[port];

    port = config_port_follow[port];
    
    return config_wck_mul[port];
}


function get_effective_outputmode(port) {
    if (config_port_output_redundancy[port]!=port) 
	port = config_port_output_redundancy[port];
    
    return config_port_mode[port];
}


function get_redundancy_status(port) {
    if (config_port_input_redundancy[port]==port)
	return -1; // no redundancy
    
    if ((status_port_sync[port]==0))
	return 1; // no signal
    
    if ((status_port_sync[port]!=3) || (status_port_sync[config_port_input_redundancy[port]]!=3))
	return 2; // no sync

    if (get_effective_source(port) != get_effective_source(config_port_input_redundancy[port]))
	return 3; // 3: clock reference differs

    if (get_effective_mul(port) != get_effective_mul(config_port_input_redundancy[port]))
	return 4; // wck mul differs

    if (status_port_mode[port] != status_port_mode[config_port_input_redundancy[port]])
	return 5; // incoming frame mode differs

    if (status_port_frame[port] != status_port_frame[config_port_input_redundancy[port]])
	return 6; // incoming frame format differs

    return 0; // we're happy :)
}


function verbose_redundancy_check(val) {
    switch (val) {
    case -1: return "No redundancy configured";
    case 0: return "OK";
    case 1: return "No signal";
    case 2: return "No sync";
    case 3: return "Clock reference differs";
    case 4: return "Speed mode differs";
    case 5: return "Different incoming frame mode";
    case 6: return "Different incoming frame format";
    }
}


function t_02d(v) {
    if (v<10) 
	return '0'+v;
    return v;
}


function t_str(t) {
    if (t>86400) {
	return Math.floor(t/86400) + "d" + t_02d(Math.floor((t%86400)/3600)) + "h" + t_02d(Math.floor((t%3600)/60)) + "'" + t_02d(Math.floor(t%60)) + '"'; 

    } else if (t>3600) {
	return Math.floor(t/3600) + "h" + t_02d(Math.floor((t%3600)/60)) + "'" + t_02d(Math.floor(t%60)) + '"'; 
    } else if (t>60) {
	return Math.floor(t/60) + "'" + t_02d(Math.floor(t%60)) + '"'; 
    } else {
	return Math.floor(t%60) + '"'; 
    }
}


function status_sync_str(id) {
    var t = status_port_t[id];
    if (status_port_t[id]>10) 
	return sync_states[status_port_sync[id]]+" for "+t_str(new Date().getTime()/1000-status_port_t[id]);
    
    return "No signal since last boot.";
}


function status_update_str(id) {
    var o = document.getElementById("details_"+id);
    if (o) {
	if (id<16)
	    o.childNodes[0].innerHTML = labels_input_ports[id];

	if (connected) {
	    if (o.style.display=='block') {
		o.childNodes[1].innerHTML = status_sync_str(id);

		if (id<17) {
		    if (status_port_sync[id]>0) {
			o.childNodes[1].innerHTML += " / "+status_port_freq[id]+"Hz";
			
			if (id<16) {
			    // MADI port
			    o.childNodes[1].innerHTML += " / "+status_port_mode[id]+"ch / "+status_port_frame[id]+"k / "+fs_strings[get_effective_mul(id)];
			    var rs = get_redundancy_status(id);
			    if (rs>0) {
				check_redundancy_real(id);
				o.childNodes[1].innerHTML += "<br><span style='color: red; font-weight: bold;'> Red. error: "+verbose_redundancy_check(rs)+"</span>";
			    }
			}
		    }
		    if (sfp_msgs[id] && (sfp_msgs[id]!="")) {
			o.childNodes[1].innerHTML += "<br>"+sfp_msgs[id];
		    }
		} else {
		    // Video
		    o.childNodes[1].innerHTML += " / "+status_video_mode;
		    o.childNodes[1].innerHTML += " / 44.1kHz: "+status_port_freq[17]+"Hz";
		    o.childNodes[1].innerHTML += " / 48kHz: "+status_port_freq[18]+"Hz";
		}
		
		if (id==16) 
		    // Wck output
		    o.childNodes[1].innerHTML += " / Output: "+wck_sources[config_poly_source[16]]+" / "+fs_strings[get_effective_mul(id)];
		
		window.setTimeout("status_update_str("+id+");", 1000);
	    }		
	} else {
	    o.childNodes[1].innerHTML = "No connection with M1k2";
	}
    }
}


function status_display(id, show) {
    var o = document.getElementById("details_"+id);
    if (o) {
	if (show) {
	    o.style.display = 'block';
	    status_update_str(id);
	} else {
	    o.style.display = 'none';
	}
    }
}

function status_show(e) {
    status_display(e.target.sync_id, true);
}

function status_hide(e) {
    status_display(e.target.sync_id, false);
}


function show_redundancy(indicator, port, img) {
    if (port==-1) {
	//indicator.style.display = 'none';
	indicator.style.backgroundImage = "url(/img/redundancy_numbers.png)";
	indicator.style.backgroundPosition = "-525px 0px";
	indicator.style.display = 'block';
    } else {
	indicator.style.backgroundImage = "url(/img/redundancy_numbers"+img+".png)";
	indicator.style.backgroundPosition = ((15-port)*30+32)+"px 0px";
	indicator.style.display = 'block';
    }
}


function check_redundancy_real(port) {
    var indicator = document.getElementById('redundancy_indicator_'+port);

    if (config_port_input_redundancy[port]==port) {
	if (indicator.status!=-1)
	    show_redundancy(indicator, -1, img);
	indicator.status = -1;
	return;
    }

    var img = "";
    var status = get_redundancy_status(port);

    if (status==1) {
	img = "_fail";
    } else if (status>=3) {
	img = "_warn";
    }

    indicator.status = status;

    show_redundancy(indicator, config_port_input_redundancy[port], img);
}


function check_redundancy(port) {
    if ((config_port_input_redundancy[port]==-1) || (config_port_input_redundancy[port]==port))
	show_redundancy(document.getElementById('redundancy_indicator_'+port), -1, "");
    
    if (config_port_input_redundancy[port]>-1) {
	check_redundancy_real(port);
	check_redundancy_real(config_port_input_redundancy[port]);
    }
}


function io_board_active(id) {
    return (status_io_present[id] && status_io_power[id]);
}


function update_io_panel(id) {
    var style = io_board_active(id)?"visible":"hidden";
    for (i=id*8; i<(id+1)*8; i++) {
	document.getElementById("sync_"+i).style.visibility = style;
	document.getElementById("details_"+i).style.visibility = style;
	document.getElementById("wck_"+i).style.visibility = style;
	document.getElementById("redundancy_indicator_"+i).style.visibility = style;
    }

    var o = document.getElementById("p"+id+"na");
    var statusbar = document.getElementById('statusbar');
    if (style=="visible") {
	if (o)
	    statusbar.removeChild(o);
    } else {
	if (!o) {
	    o = document.createElement("img");
	    o.src = "/img/status_NA.png";
	    o.className = 'na';
	    if (id==0)
		o.style.left = "156px";
	    else
		o.style.left = "396px";

	    o.id = "p"+id+"na";
	    statusbar.appendChild(o);
	}
    }
}


function update_snapshot() {
    var si = document.getElementById("snapshot_info");

    if ((status_local_control==0) || ((status_snapshot[0]=="") && (status_snapshot[3]==""))) {
	si.innerHTML = "";
    } else {
	si.innerHTML = "<span style='color: #"+status_snapshot[1]+"; background-color: #"+status_snapshot[2]+";'>"+status_snapshot[0]+"</span>/<span style='color: #"+status_snapshot[4]+"; background-color: #"+status_snapshot[5]+";'>"+status_snapshot[3]+"</span>";
	if (status_snapshot_changed)
	    si.innerHTML = si.innerHTML + " <b>*</b>";
    }
}



/**
 * 
 * EventSource callbacks
 *
 **/

function ess_key_valid(val) {
    status_key = val;
}

function ess_controller(id) {
    status_controller = id;
    if (id==1) {
	menu_items[3][3][2] = "/en/misc/licenses1.html";
    }
}

function ess_board(id) {
    status_board = id;
}

function ess_serial(serial) {
    status_serial = serial;
}

function ess_firmware(major, minor, build) {
    status_firmware[0] = major;
    status_firmware[1] = minor;
    status_firmware[2] = build;
}


function ess_io(id, serial, p1, p2, p3, p4, p5, p6, p7, p8, firmware) {
    status_io_serial[id] = serial;

    status_io_ports[id][0] = p1;
    status_io_ports[id][1] = p2;
    status_io_ports[id][2] = p3;
    status_io_ports[id][3] = p4;
    status_io_ports[id][4] = p5;
    status_io_ports[id][5] = p6;
    status_io_ports[id][6] = p7;
    status_io_ports[id][7] = p8;

    status_io_firmware[id] = firmware;
}

function ess_io_present(id, p) {
    status_io_present[id] = p;
    update_io_panel(id);
}

function ess_io_power(id, p) {
    status_io_power[id] = p;
    update_io_panel(id);
}

function ess_psu(id, s) {
    var img = document.getElementById("psu"+id);
    if (img) {
	img.src = "/img/status_led_"+((s==1)?"3":"0")+".png";
    }
    status_psu[id] = s;
}

function update_temp() {
    var img = document.getElementById("temp");
    if (img) {
	if (status_temp>=58) {
	    img.src = "/img/status_temp_3.png";
	} else if (status_temp>=45) {
	    img.src = "/img/status_temp_2.png";
	} else {
	    img.src = "/img/status_temp_1.png";
	}
	img.title = status_temp+"\u00B0C";
    }	
}

function ess_temp(temp) {
    status_temp = Math.floor(temp/100)/10;
    update_temp();
}

function ess_fan(speed) {
    status_fan = speed;
}

function ess_freq(port, freq) {
    status_port_freq[port] = freq;
    if (port==19) 
	update_freq(port);
}

function ess_port_mode(port, mode) {
    status_port_mode[port] = mode;
    check_redundancy(port);
}

function ess_port_frame(port, frame) {
    status_port_frame[port] = frame;
    check_redundancy(port);
}

function ess_sync(port, sync, t) {
    status_port_sync[port] = sync;
    status_port_t[port] = new Date().getTime()/1000 - t;

    var p = document.getElementById("sync_"+port);
    
    if (p) {
	if (status_port_sync[port]==1) 
	    p.style.backgroundImage = "url(/img/status_led_1.gif)";
	else
	    p.style.backgroundImage = "url(/img/status_led_"+status_port_sync[port]+".png)";
    }

    if (port<16)
	check_redundancy(port);
}

function ess_video_mode(mode) {
    status_video_mode = mode;
    status_update_str(17);
}

function ess_dead_channels(channels) {
    status_dead_channels = channels;
}

function ess_hwaddr(str) {
    status_hwaddr = str;
}

function ess_ipaddr(str) {
    status_ipaddr = str;
}

function ess_polysync(p) {
    status_polysync = p;
    document.getElementById('wck_poly').src = (p)?"/img/polysync_on.png":"/img/polysync_off.png";
}

function ess_usage(fs, usage) {
    status_usage[fs] = usage;
}

function ess_doppelgaenger(status) {
    status_doppelgaenger = status;
}


function dg_update() {
    var s = document.getElementById("info_master");
    if (slaves.length==0) {
	s.innerHTML = "";
    } else {
	s.innerHTML = "<a href='/en/config/device.html#mirroring' target='contents'>MASTER</a>";
    }
}

function add_slave(ip) {
    for (var i=0; i<slaves.length; i++) {
	if (slaves[i]==ip) {
	    return 0;
	}
    }
    slaves.push(ip);

    dg_update();

    return 1;
}


function ess_slave(ip) {
    add_slave(ip);
}


function ess_slave_added(ip) {
    if (add_slave(ip)) {
	if (parent.frames[1].ess_slave_added)
	    parent.frames[1].ess_slave_added(ip);
    }
}

function remove_slave(ip) {
    var i = slaves.indexOf(ip);
    if (i>=0) {
	slaves.splice(i, 1);
	dg_update();
    }
}

function ess_slave_removed(ip) {
    remove_slave(ip);
    if (parent.frames[1].ess_slave_removed)
	parent.frames[1].ess_slave_removed(ip);
}


function ess_slave_vanished(ip) {
    remove_slave(ip);
    if (parent.frames[1].ess_slave_vanished)
	parent.frames[1].ess_slave_vanished(ip);
    else
	alert("Connection with slave "+ip+" lost!");
}


function ess_local_control(val) {
    status_local_control = val;
    if (val==0) {
	if ((parent.frames[1].location.pathname!="/en/login.html") &&
	    (parent.frames[1].location.pathname!="/en/slave.html")) {
	    alert("Local control is disabled");
	}
	update_snapshot();
    } else {
	parent.frames[1].location = "/en/login.html";
    }
}


function ess_master_source(src) {
    status_master_source = src;
    update_wck();
}


function ess_wck_mode(mode) {
    status_wck_mode = mode;
}


function ess_snapshot_loaded(snap) {
    status_snapshot = snap;
    update_snapshot();
}

function ess_snapshot_changed(changed) {
    status_snapshot_changed = changed;
    update_snapshot();
}


//
//
//


function esc_master_enable_clock(enable) {
    config_master_enable_clock = enable;
    update_wck();
    for (var i=0; i<16; i++)
	check_redundancy(i);
}

function esc_master_enable_fs(enable) {
    config_master_enable_fs = enable;
    for (var i=0; i<16; i++)
	check_redundancy(i);
}

function esc_master_fallback(id, src) {
    config_master_fallback[id] = src;
}		

function esc_96k_follow(enable) {
    config_96k_follow = enable;
}

function esc_labels_inherit(enable) {
    config_labels_inherit = enable;
}


function esc_xp(m, ch_in, ch_out) {
    var old = -1;
    if (m==0) {
	old = config_xpa[ch_out];
	config_xpa[ch_out] = ch_in;

    } else if (m==1) {
	old = config_xpo[ch_out];
	config_xpo[ch_out] = ch_in;
    }

    if (old>-1) { // TODO
	if (parent.frames[1].remove_xp) {
	    parent.frames[1].remove_xp(m, old, ch_out);
	}
    }
}

function esc_al(ch, val) {
    config_lock[ch] = val;
}

function esc_gl(ch, val) {
    config_gain_lock[ch] = val;
}

function esc_gain(ch, gain) {
    config_gains[ch] = gain;
}

function esc_midixp(p_in, p_out) {
    config_midi[p_out] = p_in;
}

function esc_serxp(p_in, p_out) {
    config_ser[p_out] = p_in;
}

function esc_serbaud(p, baud) {
    config_serbaud[p] = baud;
}

function esc_poly_source(port, source) {
    config_poly_source[port] = source;

    for (var i=0; i<16; i++)
	check_redundancy(i);
    
    update_wck();
}

function esc_disable_ip_reset(val) {
    config_ip_reset = val;
}

function esc_disable_password_reset(val) {
    config_password_reset = val;
}

function esc_auto_57ch(val) {
    config_auto_57ch = val;
}

function esc_subcode(port, mode) {
    config_subcode[port] = mode;
}

function update_freq(port) {
    i441 = 'none';
    i48 = 'none';

    if (Math.abs(48000-status_port_freq[port])<48) {
	i48 = 'block';
    } else if (Math.abs(44100-status_port_freq[port])<44.1) {
	i441 = 'block';
    }

    document.getElementById('wck_48').style.display = i48;
    document.getElementById('wck_441').style.display = i441;
}

var wck_old = -1;

function update_wck() {
    var source = get_effective_source(16);
    var wck_new = '';

    /* values: 0..15=port, 16=wck,              */
    /*         17=video 44.1, 18=video 48,      */
    /*         19=internal 44.1, 20=internal 48 */

    switch (source) {
    case 17:
    case 18:
	wck_new = 'wck_video';
	break;
    case 19:
    case 20:
	wck_new = 'wck_intern';
	break;
    default:
	wck_new = 'wck_'+source;
    }

    if (wck_new != wck_old) {
	if (wck_old != -1)
	    document.getElementById(wck_old).style.display = 'none';

	var o = document.getElementById(wck_new);
	if (o) {
	    o.style.display = 'block';
	    wck_old = wck_new;
	}
    }
}


function sfp_status(modules, levels) {
    for (port=0; port<16; port++) {
	var slot = Math.floor(port/8); 
	if (status_io_ports[slot][port%8]==7) {
	    // port is a smart sfp module
	    var s = document.getElementById("sync_"+port);
	    sfp_msgs[port] = "";
	    if (modules[port]>0) {
		s.style.opacity = "1.0";
		if (modules[port]&0x40) {
		    sfp_msgs[port] += "MADI signal: "+((levels[port]-400)/10)+"dB";
		    if (modules[port]&0x02) {
			sfp_msgs[port] += " <b style='color: red;'>LOW ALARM</b>";
		    } else if (modules[port]&0x01) {
			sfp_msgs[port] += " <b style='color: red;'>HIGH ALARM</b>";
		    } else if (modules[port]&0x08) {
			sfp_msgs[port] += " <b style='color: yellow;'>LOW WARNING</b>";
		    } else if (modules[port]&0x04) {
			sfp_msgs[port] += " <b style='color: yellow;'>HIGH WARNING</b>";
		    }
		} else {
		    sfp_msgs[port] = "[no DMM]";
		}
		
	    } else {
		s.style.opacity = "0.5";
		sfp_msgs[port] += "[no SFP module]";												 
	    }
	}
    }
    
    document.getElementById("sfp_level").innerHTML = str;

    oldmodules = modules;
    oldlevels = levels;
}




function update_bg() {
    if (redundancy_active) {
	if (config_mirror>0) {
	    document.getElementById('statusbar').style.backgroundImage = "url(/img/status_blank_red_slave.png)";
	} else {
	    document.getElementById('statusbar').style.backgroundImage = "url(/img/status_blank_red.png)";
	}
    } else {
	if (config_mirror>0) {
	    document.getElementById('statusbar').style.backgroundImage = "url(/img/status_blank_slave.png)";
	} else {
	    document.getElementById('statusbar').style.backgroundImage = "url(/img/status_blank.png)";
	}
    }
}


function esc_wck_mul(port, mul) {
    config_wck_mul[port] = mul;

    for (var i=0; i<16; i++)
	check_redundancy(i);
    
    status_update_str(port);
}

function esc_wck_pll(val) {
    config_wck_pll = val;
}

function esc_port_mode(port, mode) {
    config_port_mode[port] = mode;
}

function esc_port_frame(port, frame) {
    config_port_frame[port] = frame;
}

function esc_port_input_redundancy(port, redundancy) {
    config_port_input_redundancy[port] = redundancy;
    
    check_redundancy(port);
    
    if (port!=redundancy) {
	redundancy_active = 1;
    } else {
	var i = 0;
	for (i=0; i<16; i++) {
	    if (config_port_input_redundancy[i]!=i)
		break;
	}
	
	if (i==16)
	    redundancy_active = 0;
    }
    update_bg();
}

function esc_port_output_redundancy(port, redundancy) {
    config_port_output_redundancy[port] = redundancy;
}

function esc_port_follow(port, follow) {
    config_port_follow[port] = follow;
    
    if (port==16)
	update_wck();
}

function esc_gpo(gpo, level) {
    config_gpo[gpo] = level;

    var img = document.getElementById("gpo"+gpo);
    if (img)
	img.src = "/img/status_led_"+((level==0)?0:3)+".png";
}

function esc_gpo_automation(gpo, action) {
    config_gpo_automation[gpo] = action;
}

function esc_gpo_polarity(gpo, pol) {
    config_gpo_polarity[gpo] = pol;
}

function esc_term(level) {
    config_term = level;

    var img = document.getElementById("term");
    if (img) {
	if (level==1)
	    img.style.backgroundImage = "url(/img/term_on.png)";
	else
	    img.style.backgroundImage = "url(/img/status_led_0.png)";
    }
}

function esc_blink_unsaved(val) {
    config_blink_unsaved = val;
}

function esc_state_idle(val) {
    config_state_idle = val;
}

function esc_identify(val) {
    config_identify = val;
}

function esc_device_mirror(val) {
    config_mirror = val;
    update_bg();
    update_myname(myname);

    var l = parent.frames[1].location;

    if ((val==0) && (parent.frames[1].location.pathname=="/en/slave.html")) {
	parent.frames[1].location = "/en/routing/portmatrix.html";
    } else if ((val>0) && (parent.frames[1].location.pathname!="/en/slave.html")) {
	parent.frames[1].location = "/logout";
    }
}

function esc_device_master_ip(val) {
    config_master_ip = val;
    if (config_mirror) {
	update_myname(myname);
    }
}

function esc_device_mirror_data(val) {
    config_mirror_data = val;
}

function esc_msg_level(val) {
    config_msg_level = val;
}

function esc_fan(warm, full, critical) {
    config_temps[0] = warm;
    config_temps[1] = full;
    config_temps[2] = critical;

    update_temp();
}

function esc_silent_mode(mode) {
    config_silent_mode = mode;
}

function esc_rs4xx_mode(val) {
    config_rs4xx_mode = val;
}

function esc_rs485_echo(val) {
    config_rs485_echo = val;
}

function esc_slot_power(slot, power) {
    config_slot_power[slot] = power;
}

function esc_portgain(port, gain) {
    config_portgains[port] = gain;
}

function esc_portgain_mode(port, mode) {
    config_portgain_modes[port] = mode;
}


function set_profile(id) {
    settings_profile = id;
}

function set_network(id) {
    settings_network = id;
}

function update_title() {
    if ((settings_name=="") && (pagetitle==""))
	parent.document.title = "D.O.TEC M.1k2";
    else if (settings_name=="")
	parent.document.title = pagetitle;
    else if (pagetitle=="")
	parent.document.title = settings_name;
    else
	parent.document.title = settings_name+" - "+pagetitle;
}

function set_pagetitle(str) {
    pagetitle = str;
    update_title();
}

function set_name(str) {
    settings_name = str;
    update_title();
}

function set_contact(str) {
    settings_contact = str;
}


//


function esl(type, id, label, fg, bg) {
    switch (type) {
    case 128:
	labels_audio_in[id] = label;
	labels_audio_in_fg[id] = fg;
	labels_audio_in_bg[id] = bg;
	break;
    case 129:
	labels_audio_out[id] = label;
	labels_audio_out_fg[id] = fg;
	labels_audio_out_bg[id] = bg;
	break;
    case 130:
	labels_serial_in[id] = label;
	labels_serial_in_fg[id] = fg;
	labels_serial_in_bg[id] = bg;
	break;
    case 131:
	labels_serial_out[id] = label;
	labels_serial_out_fg[id] = fg;
	labels_serial_out_bg[id] = bg;
	break;
    case 132:
	labels_midi_in[id] = label;
	labels_midi_in_fg[id] = fg;
	labels_midi_in_bg[id] = bg;
	break;
    case 133:
	labels_midi_out[id] = label;
	labels_midi_out_fg[id] = fg;
	labels_midi_out_bg[id] = bg;
	if (id==17) {
	    data_initialized = true;
	    hide_connecting();
	}
	break;
    case 134:
	labels_input_ports[id] = label;
	labels_input_ports_fg[id] = fg;
	labels_input_ports_bg[id] = bg;
	break;
    case 135:
	labels_output_ports[id] = label;
	labels_output_ports_fg[id] = fg;
	labels_output_ports_bg[id] = bg;
	break;
    }
}


//


function esc_plugin_perms(pluginid, permissionid) {
    plugin_perms[pluginid] = permissionid;
}

function esc_plugin_active(pluginid, status) {
    plugin_active[pluginid] = status;
}


//

function syslog(timestamp, facility, severity, appname, msg) {
    //alert(msg);
}


//


function system_script_tally(scriptid, status) {
    scripting_system_tally[scriptid] = status;
}


//


function esc_iomask_ports(mask) {
    iomask_ports = mask;
}

/*
  function esc_iomask_xps(src, dest, mask) {
  iomask_xps[src][dest] = mask;
  }
*/

//
//
//


var reload_mode=0;


function show_connlost(msg) {
    var div = parent.frames[1].document.getElementById("connecting");
    if (!div) {
	div = parent.frames[1].document.createElement("div");
	div.id = "connecting";
	div.innerHTML = msg;
	parent.frames[1].document.body.appendChild(div);
    }
    div.style.display = "block";
}

function hide_connecting() {
    var div = parent.frames[1].document.getElementById("connecting");
    if (div)
	div.style.display = "none";
}


function events_disconnected() {
    data_initialized = false;
    connected = 0;

    show_connlost("Connection lost, retrying..");

    for (i=1; i<21; i++) {
	img = document.getElementById("sync_"+i);
	if (img) {
	    img.src = "/img/status_led_0.png";
	}
    }
    img = document.getElementById("psu1");
    if (img) 
	img.src = "/img/status_led_0.png";
    img = document.getElementById("psu2");
    if (img) 
	img.src = "/img/status_led_0.png";
    img = document.getElementById("temp");
    if (img) 
	img.src = "/img/status_temp_0.png";

    o = document.getElementById("statusbar");
    fade_set_opacity(o, 0.5);

}


function events_connected() {
    connected = 1;

    hide_connecting();
    show_connlost("Initializing..");

    if (reload_mode==1) {
	parent.window.location = '/';
    } else {
	o = document.getElementById("statusbar");
	if (o)
	    fade_set_opacity(o, 1);
	ajax_call('/data/myname', update_myname);
	ajax_call("/data/my_time?"+Math.round((new Date().getTime()/1000)));
    }
}


function create_status_led(x, id, width, link, imgsrc, sync_id) {
    var statusbar = document.getElementById('statusbar');
    var a = document.createElement("a");
    a.className = 'portlink';
    a.href = link;
    a.target = "contents";
    if (sync_id!=-1) {
	a.sync_id = sync_id;
	a.onmouseover = status_show;
	a.onmouseout = status_hide;
    }
    a.style.left = x+"px";
    a.style.top = "43px";
    a.style.backgroundImage = 'url('+imgsrc+')';
    a.id = id;

    statusbar.appendChild(a);
}

function create_syncref(x, y, id, imgsrc) {
    var statusbar = document.getElementById('statusbar');
    var img = document.createElement("img");
    img.id = id;
    img.src = imgsrc;
    img.className = 'syncref';
    img.style.left = x+'px';
    img.style.top = y+'px';
    statusbar.appendChild(img);
}

function create_led_popup(x, id, title, contents) {
    var statusbar = document.getElementById('statusbar');
    var div = document.createElement("div");
    div.className = 'details';
    div.style.left = ((x>90)?(x-90):0)+"px";
    div.id = "details_"+id;
    div.innerHTML = "<h4>"+title+"</h4><span>"+contents+"</span>";
    statusbar.appendChild(div);
}

function create_redundancy_indicator(x, id) {
    var statusbar = document.getElementById('statusbar');
    var div = document.createElement("div");
    div.className = 'redundancy_indicator';
    div.style.left = (x+3)+"px";
    div.id = "redundancy_indicator_"+id;
    div.status = -2;
    statusbar.appendChild(div);
}


function status_init() {
    if (!("WebSocket" in window)) {
	parent.frames[1].location = '/en/browser.html';
	return;
    }

    ajax_call("/data/my_time?"+Math.round((new Date().getTime()/1000)));

    for (i=0; i<16; i++) {
	create_status_led(49+i*30, "sync_"+i, 30, "/en/config/port.html?"+(i+1), "/img/status_led_0.png", i);
	create_led_popup(49+i*30, i, "Port "+(i+1), "No signal");
	create_syncref(46+i*30, 42, "wck_"+i, "/img/status_act_"+(i+1)+".png");
	create_redundancy_indicator(49+i*30, i);
	document.getElementById("sync_"+i).style.visibility = "hidden";
	document.getElementById("details_"+i).style.visibility = "hidden";
	document.getElementById("wck_"+i).style.visibility = "hidden";
	document.getElementById("redundancy_indicator_"+i).style.visibility = "hidden";
    }

    create_status_led(594, "sync_16", 30, "/en/config/wck.html", "/img/status_led_0.png", 16);
    create_led_popup(594, 16, "Word Clock", "No signal");
    create_syncref(590, 42, "wck_16", "/img/status_act_wck.png");

    create_status_led(569, "term", 20, "/en/config/wck.html", "/img/status_led_0.png", -1);

    create_status_led(541, "sync_17", 30, "/en/config/wck.html", "/img/status_led_0.png", 17);
    create_led_popup(541, 17, "Video Input", "No signal");
    create_syncref(540, 42, "wck_video", "/img/status_act_video.png");

    create_syncref(636, 42, "wck_intern", "/img/status_act_intern.png");
    create_syncref(636, 58, "wck_441", "/img/status_act_441.png");
    create_syncref(636, 72, "wck_48", "/img/status_act_48.png");

    ws_init(events_connected, events_disconnected);

    window.setInterval(window_scan, 3000);
}


function bulk_xp(matrix, ar) {
    for (var i=0; i<1024; i++)
	esc_xp(matrix, ar[i], i);
}

function bulk_gain(data) {
    for (var i=0; i<1024; i++)
	esc_gain(i, data[i]);
}

function bulk_audio_lock(data) {
    for (var i=0; i<1024; i++)
	esc_al(i, data[0][i]);
}

function bulk_gain_lock(data) {
    for (var i=0; i<1024; i++)
	esc_gl(i, data[0][i]);
}

function bulk_label(type, ar) {
    for (i=0; i<ar.length; i++)
	esl(type, i, ar[i][0], ar[i][1], ar[i][2]);
}

status_init();

