/**
 * M1k2 user toolkit
 * @copyright Florian Faber, florian.faber@directout.eu
 * @version 1 (08.03.2012) 
 *
 **/


req = null;
opt = null;


function user_edit_close() {
	dialog_close('user_edit_store');
	req = null;
}


function cb_store_response(res) {
	if (res=="OK") {
		top.user = null;
		parent.setTimeout("notifications_show('Modifications stored');", 10);
		parent.setTimeout("config_user_init();", 20);
		setTimeout("user_edit_close()", 30);
	} else {
		alert(res);
	}		
}


function user_edit_close() {
	dialog_close('user_edit');
	req = null;
}


function cb_user_edit_cancel() {
	top.user = null;
	user_edit_close();
}


function cb_user_edit_ok() {
	var str = "";
	str += top.user_userid+"\n";
	str += ((top.user_userid===false)?"0":((document.getElementById('status').checked?"0":"1")))+"\n";
	str += get_selectactive(document.getElementById('permissionid'))+"\n";
	str += document.getElementById('username').value+"\n";
	str += document.getElementById('realname').value+"\n";
	str += escape(document.getElementById('contact').value)+"\n";
	str += (document.getElementById('auth_0').checked?"0":"1")+"\n";
	str += document.getElementById('ipv4').value+"\n";
	var p = document.getElementById('new_pass');
	if (p.value=='*****')
		str += "\n";
	else
		str += p.value+"\n";
	str += document.getElementById('admin_pass').value+"\n";
	str += get_selectactive(document.getElementById('startpage'))+"\n";
	str += top.user["permissions_optional1"]+"\n";
	str += top.user["permissions_optional2"]+"\n";
	if (top.user_userid===false) {
		post_call("/data/user_new", str, cb_store_response);
	} else {
		post_call("/data/user_change", str, cb_store_response);
	}
}


function cb_user_edit_data(res) {
	top.user = JSON.parse(res);
	var s = document.getElementById('status');
	s.checked = (top.user["status"]=="0");
	s.disabled = (top.user["id"]==0);
	
	if (top.user_clone) {
		document.getElementById('username').orig = "";
	} else {
		document.getElementById('username').orig = top.user["username"];
		document.getElementById('username').value = top.user["username"];
		document.getElementById('realname').value = top.user["realname"];
		document.getElementById('contact').value = urldecode(top.user["contact"]).replace(/^\s+|\s+$/g,"");
	}

	set_selectactive(document.getElementById('permissionid'), top.user["permission"]);
	document.getElementById('auth_'+top.user["auth_method"]).checked = true;
	user_authmethod_changed(parseInt(top.user["auth_method"], 10));
	document.getElementById('ipv4').value = top.user["ip_v4"];
	set_selectactive(document.getElementById('startpage'), top.user["startpage"]);
}


function user_edit_keyup(e) {
	if (e.keyCode==27) {
		cb_user_edit_cancel();
	}		
}


function user_check_form() {
	var ok = true;

	var o = document.getElementById('username');
	if (o.value.length==0) {
		o.style.backgroundColor = 'red';
		ok = false;
	} else {
		o.style.backgroundColor = 'white';
	}

	o = document.getElementById('realname');
	if (o.value.length==0) {
		o.style.backgroundColor = 'red';
		ok = false;
	} else {
		o.style.backgroundColor = 'white';
	}

	o = document.getElementById('permissionid');
	var permid = get_selectactive(o);
	if (!(permid>=0)) {
		o.style.backgroundColor = 'red';
		ok = false;
	} else {
		o.style.backgroundColor = 'white';
		top.user["permission"] = permid;
	}

	if (document.getElementById('auth_0').checked) {
		if (top.user_userid===false) {
			o = document.getElementById('new_pass');
			if (o.value.length<=2) {
				o.style.backgroundColor = 'red';
				ok = false;
			} else {
				o.style.backgroundColor = 'white';
			}
		}

	} else if (document.getElementById('auth_1').checked) {
		o = document.getElementById('ipv4');
		if (!o.value.match(/^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/)) {
			o.style.backgroundColor = 'red';
			ok = false;
		} else {
			o.style.backgroundColor = 'white';
		}
	}

	//if (top.user_userid===false) {
		o = document.getElementById('admin_pass');
		if (o.value.length==0) {
			o.style.backgroundColor = 'red';
			ok = false;
		} else {
			o.style.backgroundColor = 'white';
		}
		//}

	if (ok)
		enable_button('user_edit_ok');
	else
		disable_button('user_edit_ok');
}


function user_authmethod_changed(val) {
	document.getElementById('new_pass').style.display = (val==1)?"none":"block";
	document.getElementById('ipv4').style.display = (val==0)?"none":"block";
	user_check_form();
}


function cb_permissions(res) {
	var data = JSON.parse(res);
	var sel = document.getElementById('permissionid');
	
	top.perms = data["perms"];

	for (var i=0; i<data.perms.length; i++) {
		var opt = document.createElement('option');
		opt.value = data["perms"][i]["id"];
		opt.text = data["perms"][i]["name"];
		sel.add(opt);
	}
}


function cb_username(res) {
	if (res=="OK")
		user_check_form();
	else {
		alert("Username '"+document.getElementById('username').value+"' already taken.");
		disable_button('user_edit_ok');
	}
}


function username_dup() {
	var inp = document.getElementById('username');
	if (inp.value!=inp.orig)
		ajax_call("/data/check_username?"+inp.value, cb_username);
}


function user_edit_init() {
	if (top.user_clone)
		req = init_dialog("Clone User", "user_edit", 500, 450, true);
	else
		req = init_dialog("Edit User", "user_edit", 500, 450, true);

	var grid = create_grid(2);
	grid_add(grid, "");
	grid_add(grid, "<input type='checkbox' id='status' onchange='user_check_form();'> Account enabled");
	grid_add(grid, "Username:");
	grid_add(grid, "<input type='text' id='username' onkeyup='username_dup();'>");

	grid_add(grid, "Real name:");
	grid_add(grid, "<input type='text' id='realname' onkeypress='user_check_form();'>");
	grid_add(grid, "Contact:<br><span style='color: #333; font-size: 10px;'>(optional)</span>");
	grid_add(grid, "<textarea id='contact' width='200px' height='100px' onkeypress='user_check_form();'></textarea>");

	grid_add(grid, "Permission:");
	grid_add(grid, "<select id='permissionid' onchange='user_check_form();'><option value='-1'>-- please select --</option></select>");

	grid_add(grid, "Optional perms:");
	grid_add(grid, "<button onclick='open_optional_perms();'>Select..</button>");
	
	grid_add(grid, "Authentication:");
	grid_add(grid, "<input type='radio' name='auth_method' id='auth_0' value='0' onchange='user_authmethod_changed(0);'> via password:<br><input type='text' id='new_pass' value=\"*****\" onfocus='if (this.value==\"*****\") this.value=\"\";' onblur='if (this.value==\"\") this.value=\"*****\";' onkeypress='user_check_form();'><input type='radio' name='auth_method' id='auth_1' value='1' onchange='user_authmethod_changed(1);'> via IP address:");
	grid_add(grid, "");
	grid_add(grid, "<input type='text' id='ipv4' onkeypress='user_check_form();'>");	

	grid_add(grid, "Start page:");
	grid_add(grid, "<select id='startpage'><option value='/index.html'>Standard web interface</option><option value='/mobile.html'>Mobile Page</option></select>");

	dialog_add(req, grid);

	var sep = create_separator("Authentication");
	dialog_add(req, sep);

	grid = create_grid(2);
	grid_add(grid, "Your password:");
	grid_add(grid, "<input type='password' id='admin_pass' onkeypress='user_check_form();'>");
	dialog_add(req, grid);


	con = create_container("horizontal", "right");
	btn = create_button("Cancel", false, "btn_text", "user_edit_cancel", cb_user_edit_cancel);
	container_add(con, btn);
	if (top.user_clone)
		btn = create_button("Create clone", false, "btn_text", "user_edit_ok", cb_user_edit_ok);
	else
		btn = create_button("Save changes", false, "btn_text", "user_edit_ok", cb_user_edit_ok);
	container_add(con, btn);
	dialog_add_dialogbuttons(req, con);

	document.body.appendChild(req);

	this.addEventListener('keyup', user_edit_keyup, false); 
	this.focus();

	ajax_call("/data/permissions", cb_permissions);
	ajax_call("/data/get_user?"+top.user_userid, cb_user_edit_data);
	if (top.user_clone)
		top.user_userid = false;
}


function opt_perms_close() {
	dialog_close('opt_perms');
	opt = null;
}


function min(a,b) { return (a<b)?a:b; }


function cb_opt_perms_ok() {
	var new_opt_perms = 0;

	for (var i=0; i<min(16, top.perms.length); i++) {
		var o = document.getElementById("op_"+top.perms[i]["id"]);
		if (o && o.checked) {
			new_opt_perms |= (1<<(parseInt(top.perms[i]["id"], 10)-1));
		}
	}
	top.user["permissions_optional1"] = new_opt_perms;

	new_opt_perms = 0;
	for (var i=16; i<top.perms.length; i++) {
		var o = document.getElementById("op_"+top.perms[i]["id"]);
		if (o && o.checked) {
			new_opt_perms |= (1<<(parseInt(top.perms[i]["id"], 10)-17));
		}
	}
	top.user["permissions_optional2"] = new_opt_perms;

	opt_perms_close();
}

function cb_opt_perms_cancel() {
	opt_perms_close();
}

function open_optional_perms() {
	create_dialog_frame(document, "/en/dialogs/opt_perms.html", "opt_perms", 400, 400, 98, true);
}


function opt_perms_init() {
	opt = init_dialog("Optional permissions", "opt_perms", 400, 400, true);
	
	var div = document.createElement('div');
	
	div.style.height = '100%';
	div.style.overflow = 'scroll';
	dialog_add(opt, div);

	var grid = create_grid(2);
  div.appendChild(grid);
	var checked = "";

	for (var i=0; i<top.perms.length; i++) {
		grid_add(grid, "<span id='op_label_"+top.perms[i]["id"]+"'>"+top.perms[i]["name"]+"</span>");
		checked = "";
		if (top.user) {
			if (i<16) {
				if (((1<<(parseInt(top.perms[i]["id"], 10)-1))&parseInt(top.user["permissions_optional1"], 10))>0)
					checked = " checked";
			} else {
				if (((1<<(parseInt(top.perms[i]["id"], 10)-17))&parseInt(top.user["permissions_optional2"], 10))>0)
					checked = " checked";
			}
		}
		grid_add(grid, "<input type='checkbox' id='op_"+top.perms[i]["id"]+"'"+checked+">");
	}

	con = create_container("horizontal", "right");
	btn = create_button("Cancel", false, "btn_text", "opt_perms_cancel", cb_opt_perms_cancel);
	container_add(con, btn);
	btn = create_button("OK", false, "btn_text", "opt_perms_ok", cb_opt_perms_ok);
	container_add(con, btn);
	dialog_add_dialogbuttons(opt, con);

	document.body.appendChild(opt);

	if (top.user) {
		var o = document.getElementById("op_label_"+top.user["permission"]);
		if (o)
			o.style.opacity = 0.5;
		o = document.getElementById("op_"+top.user["permission"]);
		if (o)
			o.disabled = true;
	}
}


function user_new_init() {
	top.user = {"permission": 0, "permissions_optional1": 0, "permissions_optional2": 0};
	
	req = init_dialog("New Account", "user_edit", 500, 450, true);

	var grid = create_grid(2);
	grid_add(grid, "Username:");
	grid_add(grid, "<input type='text' id='username' onkeyup='username_dup();'>");
	grid_add(grid, "Real name:");
	grid_add(grid, "<input type='text' id='realname' onkeypress='user_check_form();'>");
	grid_add(grid, "Contact:<br><span style='color: #333; font-size: 10px;'>(optional)</span>");
	grid_add(grid, "<textarea id='contact' width='200px' height='100px' onkeypress='user_check_form();'></textarea>");

	grid_add(grid, "Permission:");
	grid_add(grid, "<select id='permissionid' onchange='user_check_form();'><option value='-1'>-- please select --</option></select>");

	grid_add(grid, "Optional perms:");
	grid_add(grid, "<button onclick='open_optional_perms();'>Select..</button>");

	grid_add(grid, "Authentication:");
	grid_add(grid, "<input type='radio' name='auth_method' id='auth_0' value='0' onchange='user_authmethod_changed(0);' checked> via password:<br><input type='text' id='new_pass' onkeypress='user_check_form();'><input type='radio' name='auth_method' id='auth_1' value='1' onchange='user_authmethod_changed(1);'> via IP address:<br><input type='text' id='ipv4' onkeypress='user_check_form();'>");

	grid_add(grid, "Start page:");
	grid_add(grid, "<select id='startpage'><option value='/index.html'>Standard web interface</option><option value='/mobile.html'>Mobile Page</option></select>");

	dialog_add(req, grid);

	var sep = create_separator("Administrator Authentication");
	dialog_add(req, sep);

	grid = create_grid(2);

	grid_add(grid, "Your password:");
	grid_add(grid, "<input type='password' id='admin_pass' onkeypress='user_check_form();'>");
	dialog_add(req, grid);

	con = create_container("horizontal", "right");
	btn = create_button("Cancel", false, "btn_text", "user_edit_cancel", cb_user_edit_cancel);
	container_add(con, btn);
	btn = create_button("Create account", false, "btn_text", "user_edit_ok", cb_user_edit_ok);
	container_add(con, btn);
	dialog_add_dialogbuttons(req, con);

	document.body.appendChild(req);

	ajax_call("/data/permissions", cb_permissions);
	user_authmethod_changed(0);

	this.addEventListener('keyup', user_edit_keyup, false); 
	this.focus();

	disable_button('user_edit_ok');
	document.getElementById("username").focus();
}


//
//
//


function user_edit(userid) {
	if (userid.substr && (userid.substr(0, 1)=="c")) {
		top.user_clone = true;
		top.user_userid = userid.substr(1);
	} else {
		top.user_clone = false;
		top.user_userid = userid;
	}
	create_dialog_frame(document, "/en/dialogs/user_edit.html", "user_edit", 500, 450, 98, true);
}


function user_new() {
	top.user_userid = false;
	top.user = {"permissions_optional1": 0, "permissions_optional2": 0};
	create_dialog_frame(document, "/en/dialogs/user_new.html", "user_edit", 500, 450, 98, true);
}
